#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="Classe accédant au contenu des fichiers"
#print(_FonctionDuProgramme)
_Version="1.5.1"


'''
#1.5.1
self._Tables
self._ChampsDUneTable[table]=champs
#1.5 Mysql_Select_Multiple plutot que Mysql_Select
#1.4 stmt
#1.3 correction bugs listes
'''

'''
après un select : self._NomsColonnes,self._resultats

'''

#print("version:"+_Version)
import re
import os
##################### debug
import sys

_debug_Titres=True # 
_debug_Titres=False

_debug_Log=True #
_debug_Log=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug_Log=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
#def Dprint(ligne):
def Dprint(*args, **kwargs):	
	if _debug_all==True:
		print(*args, **kwargs)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug


import mysql,datetime
import mysql.connector


class br_CDICO(dict):
	def __missing__(self, key):
		return ""		
		

class CBaseDeDonnees(object):
	""" CLASSE CFichiers(str(fich)) : un fichier """
	def __init__(self,utilisateur='utilisateur',mdp='motdepasse',hote="127.0.0.1",base='Base'):		
		Tprint('-** CBaseDeDonnees.__init__()')
		self.Initialise_Mysql_Base(utilisateur,mdp,hote,base)
		self._ChampsDUneTable=br_CDICO()
		self._Tables=[]
		
	def Initialise_Mysql_Base(self,utilisateur='utilisateur',mdp='motdepasse',hote="127.0.0.1",base='Base'):
		self._utilisateur=utilisateur
		self._mdp=mdp
		self._hote=hote
		self._base=base
		
		
	def Mysql_Connection(self,config=None):#V1.1.1
		""" connection à la base de données"""
		Tprint('-** CBaseDeDonnees.Mysql_Connection()')
		
		if config!=None :
			try:
				self._conn = mysql.connector.connect(**config)
				if self._conn.is_connected():
					Dprint('Connecté à la base mysql')
					return self._conn	
			except:
				print('!!!!!!!!!!!!!!!!!!!!!!!!!!!! pb de Mysql_Connection !!!!!!!!!!!!!!!!!!!')
				pass		
			return self._conn
			
		if config==None :
			try:
				#self._conn = mysql.connector.connect(**config)
				self._conn = mysql.connector.connect(user=self._utilisateur,password=self._mdp,host=self._hote,database=self._base)
				if self._conn.is_connected():
					Dprint('Connecté à la base mysql')
					return self._conn	
			except:
				print('!!!!!!!!!!!!!!!!!!!!!!!!!!!! pb de Mysql_Connection !!!!!!!!!!!!!!!!!!!')
				pass		
			return self._conn

	
	def Mysql_Select(self,texte):
		""" Mysql_Query(self,texte=None,typeuh="SELECT") """
		Tprint('-** CBaseDeDonnees.Mysql_Select() (>= 1.2)')
		return self.Mysql_Query(texte,typeuh="SELECT")		

				
		
		
		
	def Mysql_Insere(self,texte=None):
		""" Mysql_Query(self,texte=None,typeuh="SELECT") """
		Tprint('-** CBaseDeDonnees.Mysql_Insere() (>= 1.2)')
		return self.Mysql_Query(texte,typeuh="INSERE")
			
	def Mysql_Update(self,texte=None):
		""" Mysql_Query(self,texte=None,typeuh="SELECT") """
		Tprint('-** CBaseDeDonnees.Mysql_Update() (>= 1.2)')
		return self.Mysql_Query(texte,typeuh="UPDATE")
		
	def Mysql_Query(self,texte=None,typeuh=None):
		""" Mysql_Query2(self,texte=None,typeuh=None)\n questionne la base de données (>= 1.2 )"""
		Tprint('-** CBaseDeDonnees.Mysql_Query() (>= 1.2 )')
		Dprint(texte)
		
		if typeuh !=None :
			typeuh=typeuh.upper()
			
		if typeuh=="SELECT":
			try:
				conn=self._conn#self.Mysql_Connection()
				cursor = conn.cursor()
				cursor.execute(texte)
				self._resultats=cursor.fetchall()
				
				self._NomsColonnes=cursor.column_names
				return [True,[self._NomsColonnes,self._resultats]]
				
			except Error as e:
				print(e)
				exit(132)
				return None
			"""
			finally:			
				cursor.close()
				conn.close()
			"""	
		if typeuh=="INSERE":
			try:
				conn=self._conn
				cursor = conn.cursor()
				cursor.execute(texte)
				Dprint("INSEREE MAIS INSERTION NON VERIFIE")
				return [True,"INSEREE MAIS INSERTION NON VERIFIE"]
			except Error as e:
				print(e)
				exit(133)
				return None	

		if typeuh=="UPDATE":
			try:
				conn=self._conn
				cursor = conn.cursor()
				cursor.execute(texte)
				Dprint("update")
				conn.commit()
				return [True,"update"]
			except Error as e:
				print(e)
				exit(134)
				return None	
				
		if typeuh=="SHOW":
			try:
				conn=self._conn
				cursor = conn.cursor()
				cursor.execute(texte)
				self._resultats=cursor.fetchall()
				Dprint("show")
				conn.commit()
				return [True,self._resultats]
			except Error as e:
				print(e)
				exit(135)
				return None	
					
		#BD._conn.commit()			
	
		
	def zzzMysql_Query(self,texte=None,typeuh="SELECT"):
		""" Mysql_Query1(self,texte=None,typeuh="SELECT")\n questionne la base de données (<= 1.1.0 )"""
		Tprint('-** CBaseDeDonnees.Mysql_Query() (<= 1.1.0 )')
		Dprint(texte)
		
		
		if typeuh=="SELECT":
				
			'''
			
			self._resultats=None
			if texte!=None:
				Dprint(texte)
				
				"""
				self._resultats = self._cnx.cursor()			
				self._resultats.execute(texte)
				"""
				try:
					cursor = self._cnx.cursor()			
					cursor.execute(texte)
					self._resultats = cursor.fetchall()

				except Error as e:
					print(e)
			 
				finally:
					cursor.close()
					conn.close()	
					return self._resultats
			'''
			
			try:
				#conn = mysql.connector.connect(user='BA_user',password='oCmX8ZiEQw4lkTkf',host="127.0.0.1",database='BA')
				#conn = mysql.connector.connect(user=self._utilisateur,password=self._mdp,host=self._hote,database=self._base)
				conn=self._conn#self.Mysql_Connection()
				cursor = conn.cursor()
				#cursor.execute("SELECT * FROM boucliers")
				cursor.execute(texte)
				self._resultats=cursor.fetchall()
				self._NomsColonnes=cursor.column_names
				#print('Total Row(s):', cursor.rowcount)
				'''for res in self._resultats:
					print(res)
				'''	
				"""	un par un 
				while row is not None:
					print(row)
					row = cursor.fetchone()
				"""						
				return [self._NomsColonnes,self._resultats]
				
			except Error as e:
				print(e)
				exit(132)
				return None
			"""
			finally:			
				cursor.close()
				conn.close()
			"""	
		if typeuh=="INSERE":
			try:
				conn=self._conn
				cursor = conn.cursor()
				cursor.execute(texte)
				Dprint("INSEREE MAIS INSERTION NON VERIFIE")
				return "INSEREE MAIS INSERTION NON VERIFIE"
			except Error as e:
				print(e)
				exit(133)
				return None	
					
		BD._conn.commit()			
	
	def Mysql_Insere_Multiple(self,table="table",DONNEES=[[],[]],typeuh="TabloTablo"): #V1.4
		""" insérer une données sous forme de [ champ 1,champ2 , champ3 .. ] """
		Tprint('-** CBaseDeDonnees.Mysql_Insere_Multiple()')
		typeuh=typeuh.upper()
		tchamps=self.Mysql_ListeChamps(table)		
					
		ENTETE='INSERT INTO `'+table+'`'		
		#INSERT INTO names (name, info, age) VALUES (%s, %s, %s)
		MILIEU=' ('		
		for t in tchamps:
			MILIEU+='`'+t+'`,'
		MILIEU=MILIEU[0:-1]+') VALUES (' +  ("%s ," * len(tchamps))[0:-1] +")"
		
		
		VALEURS=()
		if typeuh=="TABLOTABLO":
			for i in range(len(DONNEES)):
				DONNEES[i]=tuple(DONNEES[i])
			VALEURS=tuple(DONNEES)
		if typeuh=="CSV;":
			Dprint("DONNEES[0:2]",(DONNEES[0:2]))
			
			for i in range(len(DONNEES)):
				Dprint("DONNEES[i]",DONNEES[i])
				Dprint(tuple(DONNEES[i].split(';')))
				DONNEES[i]=tuple(DONNEES[i].split(';'))
			
			VALEURS=tuple(DONNEES)
			
		
		Dprint(ENTETE+MILIEU)
		Dprint(VALEURS)
		Dprint("-------- ENTETE+MILIEU -----\n"+ENTETE+MILIEU)
		Dprint("-------- ------------,VALEURS -----\n",VALEURS)
		Dprint('==')
		
		self.Mysql_QueryMultiple(ENTETE+MILIEU,VALEURS)
	
	
	
	def ZZZMysql_Insere_MultipleV_1_1_0(self,table="table",DONNEES=[[],[]],typeuh="TabloTablo"): #V1.1.0
		""" insérer une données sous forme de [ champ2 , champ3 .. ] le champ 1 étant NuLL par défaut """
		Tprint('-** CBaseDeDonnees.Mysql_Insere_Multiple()')
		typeuh=typeuh.upper()
		tchamps=self.Mysql_ListeChamps(table)		
					
		ENTETE='INSERT INTO `'+table+'`'		
		#INSERT INTO names (name, info, age) VALUES (%s, %s, %s)
		MILIEU=' ('		
		for t in tchamps[1:]:
			MILIEU+='`'+t+'`,'
		MILIEU=MILIEU[0:-1]+') VALUES (' +  ("%s ," * len(tchamps[1:]))[0:-1] +")"
		
		
		VALEURS=()
		if typeuh=="TABLOTABLO":
			for i in range(len(DONNEES)):
				DONNEES[i]=tuple(DONNEES[i])
			VALEURS=tuple(DONNEES)
		if typeuh=="CSV;":
			print("DONNEES[0:2]",(DONNEES[0:2]))
			
			for i in range(len(DONNEES[0:2])):
				print("DONNEES[i]",DONNEES[i])
				print(tuple(DONNEES[i].split(';')))
				DONNEES[i]=tuple(DONNEES[i].split(';'))
			
			VALEURS=tuple(DONNEES[0:2])
			
		
		Dprint(ENTETE+MILIEU)
		Dprint(VALEURS)
		print("-------- ENTETE+MILIEU -----\n"+ENTETE+MILIEU)
		print("-------- ------------,VALEURS -----\n",VALEURS)
		print('==')
		self.Mysql_QueryMultiple(ENTETE+MILIEU,VALEURS)
	
		
					
	def Mysql_QueryMultiple(self,INS,DON):#INS="INSERT INTO names (name, info, age) VALUES (%s, %s, %s)" # DON=(('Geert', info, 30), ('Jan', info, 31))
		""" insère multiples données"""
		Tprint('-** CBaseDeDonnees.Mysql_QueryMultiple()')
		cursor = self._conn.cursor()
		cursor.executemany(INS,DON)
		self._conn.commit()
		"""
		names = (('dddddddd',5,8),('dddddddd',5,8))
		stmt_insert = "INSERT INTO tex (document,a,b) VALUES (%s, %s, %s)"
		cursor.executemany(stmt_insert, names)
		"""
		
		
					

		
		
	def Mysql_Insere0(self,table="table",DONNEES=[]):# V1.0.1
		""" insérer une données sous forme de [ champ2 , champ3 .. ] le champ 1 étant NuLL par défaut """
		Tprint('-** CBaseDeDonnees.Mysql_Insere()')
		tchamps=self.Mysql_ListeChamps(table)
		
		ENTETE='INSERT INTO `'+table+'`'
		
		MILIEU=' ('		
		for t in tchamps:
			MILIEU+='`'+t+'`,'
		MILIEU=MILIEU[0:-1]+') VALUES '
		
		VALEURS='(NULL'
		for d in DONNEES:
			VALEURS+=", '"+str(d)+"'"
		VALEURS+=')'
		
		texte=ENTETE+MILIEU+VALEURS
		
		#exit()	
		self.Mysql_Query(texte,typeuh="INSERE")
		
		#INSERT INTO `tex` (`id`, `document`, `a`, `b`) VALUES (NULL, 'dsqdqs', '2', '3');
		
		
	"""def Selectionne(self,table='table',texte=""):
		pass
		#query = ("SELECT first_name, last_name, hire_date FROM employees "    "WHERE hire_date BETWEEN %s AND %s")
	"""

	def Mysql_ListeTables(self):#['RUNES', 'Zarmes0', 'Zarmes1', 'Zarmes2', 'armes', 'armures', 'boucliers', 'boucliers0', 'boucliersV2', 'races']
		Tprint('-** CBaseDeDonnees.Mysql_ListeTables()')
		tables=[]
		texte='show TABLES'
		resultats=self.Mysql_Query(texte,"show")[1]
		tables=[]
		for (resultat) in resultats:
			ligne=(list(resultat))
			tables+=ligne
			#print(ligne)
		self._Tables=tables
		return tables
		
	def Mysql_VideTable(self,table='table'):
		""" vide les données d'une table  ( >= V1.1.1 ) """
		Tprint('-** CBaseDeDonnees.Mysql_VideTable()')
		texte="TRUNCATE `"+table+"` ;"
		
		try:
			conn=self._conn
			cursor = conn.cursor()
			res=cursor.execute(texte)
			Dprint("TRUNCATE effectué mais NON VERIFIE")
			return "TRUNCATE effectué mais NON VERIFIE"
		except Error as e:
			print(e)
			exit(1110)
			return None				
		self._conn.commit()
		self._Tables=self.Mysql_ListeTables()
		return res
		
	def Mysql_ListeChamps(self,table='table'):
		Tprint('-** CBaseDeDonnees.Mysql_ListeChamps()')
		texte="SELECT * FROM  `"+table+"` ;"		
		names=[]
		champs=self.Mysql_Query(texte,"select")[1][0]
		
		
		'''conn = mysql.connector.connect(user='BA_user',password='oCmX8ZiEQw4lkTkf',host="127.0.0.1",database='BA')
		cursor = conn.cursor()
		cursor.execute(texte)				
		champs=cursor.column_names
		NbDeChamps=len(champs)		
		'''
		self._ChampsDUneTable[table]=champs
		return champs
		
		
		
		
		
"""
function noms_champs_dune_table($mysqli, $table ) {   
	$temp="SELECT * FROM  ".$table." ;";
	$names=array();
	$result=$mysqli->query($temp);
	$field = $mysqli->field_count;
	while ($finfo = $result->fetch_field()) {
		$names[] = $finfo->name;
		}       
	return $names;    
	}   
	
"""
"""
cnx = mysql.connector.connect(user='ProtonsEtNeutron', password='feclDW0DenfKSHsd',host='127.0.0.1',database='ProtonsEtNeutron')
cursor = cnx.cursor()
#query = ("SELECT first_name, last_name, hire_date FROM employees "    "WHERE hire_date BETWEEN %s AND %s")
temp="SELECT * FROM `objets` ORDER BY id"
cursor.execute(temp)

for (rid) in cursor:
	ligne=(list(rid))
	print ( str(ligne[0]) )
	print(ligne)



"""


	



global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	#V1.1
	config = {
		'host': 'localhost',
		'database': 'archives',
		'user': 'archiveur',
		'password': '269m2GPzrA1uWpQY',
	}
	BD=CBaseDeDonnees()
	BD.Mysql_Connection(config)
	
	#BD.Mysql_Query("SELECT * FROM boucliers")
	print(BD.Mysql_ListeTables())
	print(BD.Mysql_ListeChamps('tex'))
	
	#V1.2
	print('NNM=BD.Mysql_Select("SELECT `NomLong`,`NomCourt`,`md5` FROM `BLENDERS` WHERE `NomLong` LIKE \'%/media/homeuhW%\' LIMIT 0,2;")')
	print('NNM=BD.Mysql_Insere("...;")')
	print('NNM=BD.Mysql_Update("...;")')

		
	#BD.Mysql_VideTable('tex')

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

"""
texte="INSERT INTO tex (document,a,b) VALUES ('dddddddd',5,8)"
print(texte)
conn=BD._conn#self.Mysql_Connection()
cursor = conn.cursor()
print('frr')
cursor.execute(texte)
"""
	
	
	
	
"""
#print (cursor)
cursor2 = cnx.cursor()
for (rid) in cursor:
	#print (rid)
	#print list(rid)
	cnx2 = mysql.connector.connect(user='windpy', password='d',host='127.0.0.1',database='wind09python')
	temp2=" select * from wind_patients_journalier where no_patient = "+str((list(rid))[0])+"  order by date,heure ";
	cursor2 = cnx2.cursor()
	cursor2.execute(temp2)
	for a in cursor2:
		b=list(a)
		#print(str(b[2]))
		date=str(b[2]).split('-')
		jour=int(date[2])
		mois=int(date[1])
		an=date[0]
		#print(b[1])
		#print(b[1],jour,mois,an,str(b[5]))#.split("'")[1])
		print('bpy.ops.mesh.primitive_cube_add(view_align=False, enter_editmode=False, location=('+str(multx*(jour+mois*31))+', '+str(multy*(b[1]))+', 0 ), rotation=(0, 0, 0), layers=(True, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False, False))')

	cursor2.close()	
	#temp2=" select * from wind_patients_journalier where no_patient = 30  order by date,heure "
	#print (temp2)	
	'''cursor2.execute(temp2)
	for a in cursor2:
		print(a)
	'''

	#print("{}, {} was hired on {:%d %b %Y}".format(last_name, first_name, hire_date))
	#print("{}, {} was hired on {:%d}".format(rid))

#  

cursor.close()
cnx.close()
print(temp2)

#http://dev.mysql.com/doc/connector-python/en/myconnpy_example_connecting.html

'''



query = ("SELECT first_name, last_name, hire_date FROM employees "
         "WHERE hire_date BETWEEN %s AND %s")

temp="select * from `wind_patients` order by `no_centre`,`no_dans_le_centre`";
cursor.execute(temp)


temp2=" select * from `wind_patients_journalier` where `no_patient` = ".$row[0]."  order by `date`,`heure` ";  

hire_start = datetime.date(1999, 1, 1)
hire_end = datetime.date(1999, 12, 31)
cursor.execute(query, (hire_start, hire_end))
for (first_name, last_name, hire_date) in cursor:
	print("{}, {} was hired on {:%d %b %Y}".format(last_name, first_name, hire_date))
cursor.close()
cnx.close()
'''

#http://dev.mysql.com/doc/connector-python/en/myconnpy_example_connecting.html
"""
