from __future__ import print_function
# -*- coding: utf-8 -*-
#http://docs.scipy.org/doc/numpy/reference/generated/numpy.matrix.html
#http://docs.scipy.org/doc/numpy/reference/routines.linalg.html

#On travaille ici avec des <class 'numpy.ndarray'>
# getA transforme <class 'numpy.matrixlib.defmatrix.matrix'> en <class 'numpy.ndarray'>
# marche peut etre avec <class 'numpy.matrixlib.defmatrix.matrix'>
_FonctionDuProgramme="travail avec les matrices\n"
#print(_FonctionDuProgramme)
_Version="2.1.3"
"""
V2.1.3 correction de self.Norme() et self.ProduitScalaire(B):
V2.1.2 dims()
V2.1 : def __add__
V2.1.1 : inv erse
"""


'''
EN UNE LIGNE 
from CMatrixMatrices import *
m=CMatrice([[5,2,-6],[-2,0,3],[2,1,-2]])
P=CMatrice([[-1,0,2],[3,1,-4],[2,1,-3]])
	
print((P * m * P.Inverse())._mat)





'''
##################### debug
import sys

_debug_Titres=True # 
_debug_Titres=False

_debug_Log=True #
_debug_Log=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug_Log=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+sys.argv[0]+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
#def Dprint(ligne):
def Dprint(*args, **kwargs):	
	if _debug_all==True:
		print(*args, **kwargs)
		print('--------------------------')
		
def Eprint(*args, **kwargs):			
	Dprint(*args, **kwargs)
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""



import numpy
import numpy as np
from numpy import *#array,zeros,ones,getH

class CVecteur(object):
	""" CLASSE CVecteur """
	def __init__(self,V=2,direction="vertical",contient="0"):
		if direction=="horizontal" or direction=="h":
			self._vec=CMatrice(M=(V,1),contient=contient)._mat
		else:
			print((1,V),contient)
			self._v=CMatrice(M=(1,V),contient=contient)._mat
	
	def ProduitScalaire(self,v):
		return ProduitScalaire

	def vec(self,v2):
		V=3
		res=CVecteur(V)
		pt1=list(self._v)+list(self._v)
		pt2=list(v2._v)+list(v2._v)
		for i in range(V):
			res[i]=pt1[i+1]*pt2[i+2]-pt1[i+2]*pt2[i+1]
		return CVecteur(res)
	


class CMatrice(object):
	""" CLASSE CMatrice """
	def __init__(self,M=(1,1),contient="0"):#contient="0" 0 partout ou "I" diagonale de 1
		""" base : CMatrice((1,1),"0")=(0.0) \ 
				CMatrice((1,3),"0")=(0,0,0)
				CMatrice(numpy matrix)
				CMatrice([[1],[2],[3]])
		"""		
		#self._dims=(l,c)
		self._mat=None
		
		
		if str(type(M))=="<class 'numpy.matrixlib.defmatrix.matrix'>":
			self._mat=M
			self._dims=M.shape#(len(M),len(M[0]))
		
		elif isinstance(M,tuple):#str(type(M))=="<class 'tuple'>":#(dim1,dim2)
			m,n=M[0],M[1]
			if contient=="0":
				self._mat=MatmnNulle(m,n)
				self._dims=(m,n)
			elif contient=="I" and m==n:
				self._mat=MatnUnite(m)
				self._dims=(m,m)
			elif contient=="I" and m!=n:
				self._mat=MatmnNulle(m,n)
				self._dims=(m,n)
				for i in range(min(m,n)):		
					self._mat[i,i]=1
		
				
			else:
				self._mat="erreur58 0/I" 	
				
		else:#str(type(M))="<class 'list'>":
			m=len(M)
			n=len(M[0])			
			self._mat=MatmnNulle(m,n)
			self._dims=(m,n)
			
			for i in range(m):
				for j in range(n):					
					self._mat[i,j]=M[i][j] 
					
	def __format__(self):
		return str(self._mat)
					
	def dims(self):#
		self._dims=(len(self._mat),len(self._mat[0]))
		return erreurself._dims
		
	def __add__(self,MAT):
		return CMatrice(self._mat+MAT._mat)
	
	def __pow__(self,n):
		Tprint("__mul__")
		if isinstance(n,int):
			if n==0:
				res=MatnUnite(self._dims[0])
			if n>0:	
				A=self._mat
				for i in range(n-1):
					A=A * self._mat
				return CMatrice(A)
		else:
			return None
	
	def exp(self,n):
		return self.__pow__(n)
	
	def __repr__(self):
		return self._mat
		
		
		
	def __mul__(self,MAT):
		Tprint("__mul__")
		if isinstance(MAT,CMatrice):		
			return CMatrice(self._mat * MAT._mat)
		else:
			return CMatrice(MAT * self._mat)	
		
	def __rmul__(self,MAT):
		Tprint("__rmul__")
		if isinstance(MAT,CMatrice):
			return CMatrice(MAT*self._mat)
		else:	
			return CMatrice(MAT * self._mat)

	
	def Transposee(self):
		return CMatrice(  (numpy.matrix(self._mat).getT()).getA() )
		
	def Determinant(self):
		return Determinant(self._mat)
		
	def T(self):
		return self.Transposee()	
	
	def Norme(self):
		#return sqrt((self.Transposee()*self)._mat[0])
		return sqrt((self.Transposee()*self)._mat[0,0]) #V2.1.3
		
	def ProduitScalaire(self,B):		
		#return (self.Transposee()*B)._mat[0]
		return (self.Transposee()*B)._mat[0,0] #V2.1.3
		
	
	def Inverse(self,zero=None,arrondi=None):
		a=CMatrice(self._mat.getI())
		
		if (isinstance(zero,float) and zero > 0):
			for i in range(self._dims[0]):
				for j in range(self._dims[1]):
					if abs(a._mat[i,j])<zero:
						a._mat[i,j]=0.0
		if (isinstance(arrondi,int)):
			for i in range(self._dims[0]):
				for j in range(self._dims[1]):
					a._mat[i,j]=round(a._mat[i,j],arrondi)					
		return a
	
	def is_TriangulaireSup(self):
		for i in range(1,self._dims[0]):
			for j in range(0,i-1):
				if self._mat[i,j]!=0:
					return False
		return True			
	
	
	
	
	def DiagonalisationParQR_HOUSEHOLDER(self):
		""" DiagonalisationParQR_HOUSEHOLDER """
		def sgn(a):
			if a>0 : return 1
			elif a==0: return 0
			else: return -1
		def CalculDeQk(MAT,k):
			X=CMatrice(self._dims[0]-k,1)
			if X.norme()==X._mat[0][0]^2:
				Q=CMatrice(self._dims,"I")				
				
			else:
				e1 = Cmatrice(MAT._dims[0])
				e1._mat[0][0]=1.0
				alpha= - sgn(X[0]) * X.norme()
				u=X-alpha*e1
				V=u/u.norme()
				Q= I +(- 2) *  V * V.T()
			return Q	
			
		A=	CMatrice(self._mat)
		R=CMatrice(self._mat)
		k=0
		while not R.is_TriangulaireSup():
			
			R=R.rmul(CalculDeQk(A,k))
			k=k+1
			A=CMatrice((A._dims[0]-1,A._dims[1]-1))			
			for i in range(A._dims[0]):
				for j in range(A._dims[1]):
					A._mat[i,j]=R._mat[i+1,j+1]
			
		
		
		
	def VpVp(self):
		N=self._dims[0]
		ValeursPropres,VecteursPropres=np.linalg.eig(self._mat)
		
		print((list(VecteursPropres)[0])[0])
		
		for i in range(len(VecteursPropres)):
			print("VecteursPropres[i]",VecteursPropres[i,0])
			tmp=CMatrice((N,1))
			for ii in range(N):
				print(tmp._mat[ii,0])
				print(VecteursPropres[i,ii])
				tmp._mat[ii,0]=VecteursPropres[i,ii]
			VecteursPropres[i]=tmp
		return ValeursPropres,VecteursPropres
	
	
		
	def diagonalisation(self,Arrondi=1E-100):
		self._DIAGONALISATION=br_CDICO()
		
		
		
		ValeursPropres,VecteursPropres,D,P=DiagonalisationParPuissance(self._mat)
		
		
		
		'''
		print(ValeursPropres)
		
		for L in range(len(ValeursPropres)):
			ValeursPropres[L]=round(ValeursPropres[L],int(log(ValeursPropres[L]))+6)
		
		print(ValeursPropres)
		'''
		
		self._DIAGONALISATION["ValeursPropres"]=ValeursPropres
		self._DIAGONALISATION["VecteursPropres"]=VecteursPropres
		self._DIAGONALISATION["D"]=D
		self._DIAGONALISATION["P"]=P
				
		return ValeursPropres,VecteursPropres,D,P,self._DIAGONALISATION
		

def MatmnNulle(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return numpy.matrix(numpy.zeros((m,n)))
	
def MatnNulle(n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return MatmnNulle(n,n)
		
def MatmnUn(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return numpy.matrix(ones((m,n)))

def MatnUn(n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return MatmnUn(n,n)

def MatnUnite(n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	M=MatnNulle(n).getA()
	for i in range(n):
		M[i][i]=1.0
	return numpy.matrix(M)















def Mprint(M):
	if (isinstance(M,CMatrice)):
		print(M._mat)



def MatriceCarree(M):#<class 'bool'>
	if (M.shape)[0]==(M.shape)[1]:
		return True
	else:
		return False	

def Dimensions(M):#<class 'tuple'>
	return ( (M.shape)[0] , (M.shape)[1] )



def Determinant(M):#<class 'numpy.float64'>
	if MatriceCarree(M)==True:
		return numpy.linalg.det(M)
	else:
		print('(EE) Determinant : matrice non carree')
		return None

def Conjuguee(M):
	return (numpy.matrix(M).getH()).getA()	

def Transposee(M):
	return (numpy.matrix(M).getT()).getA()
	
def SousMatrice(M,a,b):#on enleve ligne a colonne b
	dim=Dimensions(M)
	N=MatmnNulle(dim[0]-1,dim[1]-1)#<class 'numpy.ndarray'>	
	for i in range(dim[0]):
		if i<a:
			ii=i
		else:
			ii=i-1
		for j in range(dim[1]):
			if j<b:
				jj=j
			else:
				jj=j-1	
			if i!=a and j!=b:
				N[ii][jj]=M[i][j]			
	return N

def DeterminantParSousMatrices(M):
	N=Dimensions(M)[0]
	if N>1:
		det=0.0
		for i in range(N):
			det+=(1-2*(i%2))*M[0][i]*DeterminantParSousMatrices(SousMatrice(M,0,i))
			#print(i,(1-2*(i%2)),DeterminantParSousMatrices(SousMatrice(M,0,i)))
		return det	
	else:
		return M[0][0]
		
def MatFoisMat(M1,M2):
	p,q=Dimensions(M1)
	q,r=Dimensions(M2)
	M3=MatmnNulle(p,r)	
	for i in range(p):
		for j in range(r):
			s=0.0
			for k in range(q):
				s+=M1[i][k]*M2[k][j]
		M3[i][j]=s
	return M3	
	
def ProduitScalaire(A,B):	
	if len(A) != len(B):
		return None
	else:
		s=0.0
		for i in range(len(A)):
			s+=A[i][0]*B[i][0]
		return float(s)

def Norme(A):
	return sqrt(ProduitScalaire(A,A))


	
	
	
def DiagonalisationParPuissance(M):	
	""" DiagonalisationParPuissance : trouve Vp si V0 not in Transp(Vect(Vp)) """
	def puissance(A,tol,nmax):
		n=len(A)
		y=MatmnNulle(n,1)
		y[1][0]=1.1
		v=ProduitScalaire(y,A*y)
		Dprint("y",y)
		Dprint("A*y",A*y)
		res=tol+1
		niter=1
		
		while (res>=tol)and(niter<=nmax):
			Ay=A*y
			Dprint("A*y=",A*y)
			vy=v*y
			Ay_vy=Ay-vy
			res=Norme(Ay_vy)
			y=A*y
			norm_y=Norme(y)
			y=( 1.0/norm_y ) * y 
			Dprint("y=",y)
			v=ProduitScalaire(y,A*y)
			niter+=1
			if niter>nmax:
				return None		
		return v,y
			

	def deflation(A,tol,niter):	
		""" deflation : trouve un couple valeur propre/vecteur propre puis recalcul avec une nouvelle matrice 	A'=A-v*y*Transposee(y) car A'y=0 """
		n=len(A)
		list_vp,list_yp,v,p = "","","",""
		try:
			v,y=puissance(A,tol,niter)
			list_vp=[v]
			list_yp=[y]
			for compteur in range(n-1):	
				#print("compteur,n=",compteur,n)		
				#A=[[A[i][j]-v*y[i]*y[j] for j in range(n)] for i in range(n)]
				#A=numpy.matrix(A)	
				Dprint(A)
				Dprint(v*y*		Transposee(y))
				Eprint('v=',v)
				A=A-v*y*Transposee(y)
				v,y=puissance(A,tol,niter)
				list_vp.append(v)
				list_yp.append(y)
			
			return list_vp,list_yp
		except:
			return "Erreur312",[(list_vp,list_yp),(v,p)]

	
	ValeursPropres,VecteursPropres=deflation(M,1.0E-8,1e2)
	if ValeursPropres=="Erreur312":
		return "Erreur317","","",""
				
	Dprint(' **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** ')
	N=len(M)
	
	MatriceDiagonale=MatmnNulle(N,N).getA()
	MatriceDeTransition=MatmnNulle(N,N).getA()
	for i in range(N):
		MatriceDiagonale[i][i]=ValeursPropres[i]
	for i in range(N):
		for j in range(N):
			MatriceDeTransition[i][j]=VecteursPropres[j][i]
	return ValeursPropres,VecteursPropres,numpy.matrix(MatriceDiagonale),numpy.matrix(MatriceDeTransition) #M= MDT * D * MDT-1
	
def Vecteur(n):
	return MatmnNulle(n,1)

def Vecteur3(x=0,y=0,z=0):
	v=Vecteur(3)
	v[0],v[1],v[2]=x,y,z
	return v


	
	






































	
	
if True==False:	
	"""
	
	#L=2
	vp=2.0
	m2._mat=m._mat-vp*CMatrice((3,3),"I")._mat
	m2=m2._mat
	print(m2)
	n=3
	for i in range(n-1):
		print("i=",i)
		if m2[i,i] == 0:
			print('zero')
			ligne=[ k for k in range(i+1,n) if m2[k,i]!=0][0]#sans zero en k,i
			print(ligne)
			for j in range(n):#que des zeros avant
				m2[i,j]+=m2[ligne,j]
			print(m2)
		for ii in range(i+1,n):
			print('i,ii=',i,ii)
			for j in range(n):#que des zeros avant				
				m2[ii,j]=m2[ii,j]-m2[i,j]*m2[ii,i]/m2[i,i]
			print(m2)	
			
				
	
	
	"""
	
	m2=CMatrice()
	#print(m.diagonalisation())
	
	ValeursPropres,VecteursPropres,D,P,_DIAGONALISATION=m.diagonalisation()
	
	print("ValeursPropres")
	print(ValeursPropres)
	print(numpy.linalg.eigvalsh(m._mat))
	
	exit()
	'''
	print("VecteursPropres")
	print(VecteursPropres)
	print("D")
	print(D)
	print("P")
	print(P)
	'''
	
	
	m2._mat=m._mat-ValeursPropres[0]*CMatrice((2,2),"I")._mat
	print(m._mat)
	print(m2._mat)
	print(Determinant(m2._mat))
	print("rr")
	
	
	
		
	for i in range(10):
		m2._mat=m._mat-round(ValeursPropres[0],i)*CMatrice((2,2),"I")._mat
		print(i,Determinant(m2._mat))
	
	
	exit()
	
	
	"""
	'''
	M1=MatmnNulle(1,5)
	M2=MatmnNulle(5,1)
	M=[[2.0, 5.0], [0.0, 4.0]]
	D=numpy.matrix([[2.0, 0.0], [0.0, 4.0]])
	P=numpy.matrix('[1.,5.;0.0,2.]')
	print("d=",D)
	print("p=",P)
	print("p-1=",P.getI())
	print("PP-1=",P*P.getI())
	print("PDP-1=",P*D*P.getI())
	#print("P-1DP=",P.getI()*D*P)
	print("DP-1=",D*P.getI())
	'''
	'''
	print('diagonalisation')
	M=numpy.matrix([[0.5,0.25], [2.0,2.0]])
	ValeursPropres,VecteursPropres,D,P=DiagonalisationParPuissance(M)
	print("ValeursPropres")
	print(ValeursPropres)
	print("VecteursPropres")
	print(VecteursPropres)
	print("D")
	print(D)
	print("P")
	print(P)
	'''
	"""
	print(ValeursPropres[1] * VecteursPropres[1] , M*VecteursPropres[1] )


"""
M=MatnUnite(3)
print(Determinant(M))
print(DeterminantParSousMatrices(M))
"""

"""
'''
M = numpy.matrix('[1,1,1,1,1,1,1,1;1,1,1,1,0,0,0,0;1,0,1,0,1,0,1,0;1,1,0,0,1,1,0,0;1,0,1,0,0,0,0,0;1,1,0,0,0,0,0,0;1,0,0,0,1,0,0,0;1,0,0,0,0,0,0,0]')
#B = M A  A = M-1 B
B=numpy.matrix('[800;300;352;424;188;166;208;144]')
print()
print(M.getI() * B)
print(numpy.linalg.det(M))
'''

'''
M=MatnUnite(3)
for i in range(3):
	for j in range(3):
		M[i][j]=(1+i)*j**3
'''
		



'''
print(type(MatriceCarree(M)))
print(type(Dimensions(M)))
print(type(MatmnNulle(m=1,n=1)))
print(type(MatnNulle(n=1)))
print(type(MatnUnite(n=1)))
print(type(Determinant(M)))
print(type(Conjuguee(M)))
print(type(Transposee(M)))

print(M)
print(SousMatrice(M,2,1))

M=MatmnUn(3,3)
N=MatmnUn(3,3)
#print(N*M)

'''


'''Methods
all([axis, out]) 	Test whether all matrix elements along a given axis evaluate to True.
any([axis, out]) 	Test whether any array element along a given axis evaluates to True.
argmax([axis, out]) 	Indices of the maximum values along an axis.
argmin([axis, out]) 	Return the indices of the minimum values along an axis.
argpartition(kth[, axis, kind, order]) 	Returns the indices that would partition this array.
argsort([axis, kind, order]) 	Returns the indices that would sort this array.
astype(dtype[, order, casting, subok, copy]) 	Copy of the array, cast to a specified type.
byteswap(inplace) 	Swap the bytes of the array elements
choose(choices[, out, mode]) 	Use an index array to construct a new array from a set of choices.
clip(a_min, a_max[, out]) 	Return an array whose values are limited to [a_min, a_max].
compress(condition[, axis, out]) 	Return selected slices of this array along given axis.
conj() 	Complex-conjugate all elements.
conjugate() 	Return the complex conjugate, element-wise.
copy([order]) 	Return a copy of the array.
cumprod([axis, dtype, out]) 	Return the cumulative product of the elements along the given axis.
cumsum([axis, dtype, out]) 	Return the cumulative sum of the elements along the given axis.
diagonal([offset, axis1, axis2]) 	Return specified diagonals.
dot(b[, out]) 	Dot product of two arrays.
dump(file) 	Dump a pickle of the array to the specified file.
dumps() 	Returns the pickle of the array as a string.
fill(value) 	Fill the array with a scalar value.
flatten([order]) 	Return a copy of the array collapsed into one dimension.
getA() 	Return self as an ndarray object.
getA1() 	Return self as a flattened ndarray.
getH() 	Returns the (complex) conjugate transpose of self.
getI() 	Returns thrns the (multiplicative) inverse of invertible self.
getT() 	Retue transpose of the matrix.
getfield(dtype[, offset]) 	Returns a field of the given array as a certain type.
item(*args) 	Copy an element of an array to a standard Python scalar and return it.
itemset(*args) 	Insert scalar into an array (scalar is cast to array's dtype, if possible)
max([axis, out]) 	Return the maximum value along an axis.
mean([axis, dtype, out]) 	Returns the average of the matrix elements along the given axis.
min([axis, out]) 	Return the minimum value along an axis.
newbyteorder([new_order]) 	Return the array with the same data viewed with a different byte order.
nonzero() 	Return the indices of the elements that are non-zero.
partition(kth[, axis, kind, order]) 	Rearranges the elements in the array in such a way that value of the element in kth position is in the position it would be in a sorted array.
prod([axis, dtype, out]) 	Return the product of the array elements over the given axis.
ptp([axis, out]) 	Peak-to-peak (maximum - minimum) value along the given axis.
put(indices, values[, mode]) 	Set a.flat[n] = values[n] for all n in indices.
ravel([order]) 	Return a flattened array.
repeat(repeats[, axis]) 	Repeat elements of an array.
reshape(shape[, order]) 	Returns an array containing the same data with a new shape.
resize(new_shape[, refcheck]) 	Change shape and size of array in-place.
round([decimals, out]) 	Return a with each element rounded to the given number of decimals.
searchsorted(v[, side, sorter]) 	Find indices where elements of v should be inserted in a to maintain order.
setfield(val, dtype[, offset]) 	Put a value into a specified place in a field defined by a data-type.
setflags([write, align, uic]) 	Set array flags WRITEABLE, ALIGNED, and UPDATEIFCOPY, respectively.
sort([axis, kind, order]) 	Sort an array, in-place.
squeeze([axis]) 	Remove single-dimensional entries from the shape of a.
std([axis, dtype, out, ddof]) 	Return the standard deviation of the array elements along the given axis.
sum([axis, dtype, out]) 	Returns the sum of the matrix elements, along the given axis.
swapaxes(axis1, axis2) 	Return a view of the array with axis1 and axis2 interchanged.
take(indices[, axis, out, mode]) 	Return an array formed from the elements of a at the given indices.
tobytes([order]) 	Construct Python bytes containing the raw data bytes in the array.
tofile(fid[, sep, format]) 	Write array to a file as text or binary (default).
tolist() 	Return the matrix as a (possibly nested) list.
tostring([order]) 	Construct Python bytes containing the raw data bytes in the array.
trace([offset, axis1, axis2, dtype, out]) 	Return the sum along diagonals of the array.
transpose(*axes) 	Returns a view of the array with axes transposed.
var([axis, dtype, out, ddof]) 	Returns the variance of the matrix elements, along the given axis.
view([dtype, type]) 	New view of array with the same data.
'''

'''
Attributes
A 	Return self as an ndarray object.
A1 	Return self as a flattened ndarray.
H 	Returns the (complex) conjugate transpose of self.
I 	Returns the (multiplicative) inverse of invertible self.
T 	Returns the transpose of the matrix.
base 	Base object if memory is from some other object.
ctypes 	An object to simplify the interaction of the array with the ctypes module.
data 	Python buffer object pointing to the start of the array’s data.
dtype 	Data-type of the array’s elements.
flags 	Information about the memory layout of the array.
flat 	A 1-D iterator over the array.
imag 	The imaginary part of the array.
itemsize 	Length of one array element in bytes.
nbytes 	Total bytes consumed by the elements of the array.
ndim 	Number of array dimensions.
real 	The real part of the array.
shape 	Tuple of array dimensions.
size 	Number of elements in the array.
strides 	Tuple of bytes to step in each dimension when traversing an array.
'''
"""




































global main
def CMAIN():
	pass
if __name__ == "__main__":
	
	m=CMatrice([[1,2,-2],[2,1,-2],[2,2,-3]])

	m.VpVp()
	exit()

	print('diagonalisation')
	M=numpy.matrix([[1,2,-2],[2,1,-2],[2,2,-3]])
	ValeursPropres,VecteursPropres,D,P=DiagonalisationParPuissance(M)
	
	ValeursPropres,VecteursPropres,D,P=DiagonalisationParPuissance(M)
	print("ValeursPropres")
	print(ValeursPropres)
	print("VecteursPropres")
	print(VecteursPropres)
	print("D")
	print(D)
	print("P")
	print(P)
	exit()
	
	m=CMatrice([[1,2,-2],[2,1,-2],[2,2,-3]])
	
	ValeursPropres,VecteursPropres,D,P=m.diagonalisation()
	print("ValeursPropres")
	print(ValeursPropres)
	print("VecteursPropres")
	print(VecteursPropres)
	print("D")
	print(D)
	print("P")
	print(P)
	
	m=CMatrice([[1,2],[0,1]])
	nm=CMatrice([[5,3],[0,1]])
	
	print("(m)._mat=",(m)._mat)
	print("(nm)._mat=",(nm)._mat)
	print("type(m._mat+nm._mat) = ",type(m._mat+nm._mat))
	a=m.__mul__(nm)
	a=m*nm
	print(a._mat)
	
	
	a=m*5
	a=5*m
	print("a=",a._mat)
	
	
	
	
	
	
	
	
	
	'''M1=MatmnNulle(1,5)
	M2=MatmnNulle(5,1)
	M=[[2.0, 5.0], [0.0, 4.0]]
	D=numpy.matrix([[2.0, 0.0], [0.0, 4.0]])
	P=numpy.matrix('[1.,5.;0.0,2.]')
	print("d=",D)
	print("p=",P)
	print("p-1=",P.getI())
	print("PP-1=",P*P.getI())
	print("PDP-1=",P*D*P.getI())
	#print("P-1DP=",P.getI()*D*P)
	print("DP-1=",D*P.getI())
	'''
	
	print('diagonalisation')
	M=numpy.matrix([[0.5,0.25], [0.0,2.0]])
	ValeursPropres,VecteursPropres,D,P=DiagonalisationParPuissance(M)
	print("ValeursPropres")
	print(ValeursPropres)
	print("VecteursPropres")
	print(VecteursPropres)
	print("D")
	print(D)
	print("P")
	print(P)
	'''
	
	'''
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	exit()
	
	
	"""
	print("from CMatrixMatrices import * ")
	
	print( "m=CMatrice((1,4),'0')")		
	print("v=CVecteur(3)")		
	print("m=CMatrice([[1,2],[0,1]])")
	
	print('--------')
	
	
	print("def MatriceCarree(M):#<class 'bool'>")
	print("def Dimensions(M):#<class 'tuple'>")
	print("def MatmnNulle(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatnNulle(n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatmnUn(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatnUn(n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatnUnite(n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def Determinant(M):#<class 'numpy.float64'>")
	print("def Conjuguee(M):")
	print("def Transposee(M):")
	print("def SousMatrice(M,a,b):#on enleve ligne a colonne b")
	print("def DeterminantParSousMatrices(M):")
	print("def MatFoisMat(M1,M2):")
	print("def ProduitScalaire(A,B):	")
	print("def Norme(A):")
	print("def DiagonalisationParPuissance(M):	")
	print("	def puissance(A,tol,nmax):")
	print("	def deflation(A,tol,niter):		")
	print("	ValeursPropres,VecteursPropres=deflation(M,1.0E-8,1e6)")
	print("def Vecteur(n):")
	print("def Vecteur3(x=0,y=0,z=0):")
	"""
	
	
	
	
	

	m2=CMatrice()
	
	m=CMatrice([[1,1,8],[3,-1,-2],[4,-4,5]])
	
	m=CMatrice([[2,2,1],[-1,1,-1],[-1,-3,0]])
	
	m2._mat=m._mat-2*CMatrice((3,3),"I")._mat
	print(Determinant(m2._mat))
	
	
