from __future__ import print_function
#!/usr/bin/python3
# -*- coding: utf-8 -*-

_FonctionDuProgramme="Classe accédant au contenu des fichiers\n\
CFichierContenu().OuvreFichier\n\
CFichierContenu().Lignes\n\
CFichierContenu().FermeFichier\n\
CFichierContenu().TrouveIntervalle\n\
CFichierContenu().EcritFichier\n\
CFichierBinaire()...\n"
_FonctionDuProgramme+="Nécessite les classes re,os,sys,CFichiersRepertoires\n" 
#print(_FonctionDuProgramme)
_Version="1.3.0"
_importe="re,os,sys,CFichiersRepertoires-V1.0.9,mysql,datetime,mysql.connector-V2.1.6-1"

"""
1.3.1 self._ouvert True/False
1.2.6 écriture de CoupeEnDeux  ; CUT
1.2.5 qqs docs
1.2.4 CFichierBinaire devient un autre py
#1.2.3 CFichierBinaire non utilisé
#print("version:"+_Version)
#1.2.1 : on enlève exit(0) si erreur douverture de fichier
"""

import re
import os
##################### debug
import sys

_debug_Titres=True # 
_debug_Titres=False

_debug_Log=True #
_debug_Log=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug_Log=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+sys.argv[0]+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
#def Dprint(ligne):
def Dprint(*args, **kwargs):	
	if _debug_all==True:
		print(*args, **kwargs)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""


import CFichiersRepertoires
from CFichiersRepertoires import CFichiersRepertoires,CFichiers


#fichier binaire http://www.chicoree.fr/w/Lire_et_%C3%A9crire_un_fichier_binaire_avec_Python#C.27est_quoi.2C_un_fichier_binaire.3F

def	TableauToString(tablo):
	texte=""
	for t in tablo:
		if isinstance(t,str):
			texte+=t
		else:
			return None	
	return texte		

class CExtensions(object):
	""" liste de sextensions de fichiers """
	def __init__(self,rep=''):
		self._Images=['jpg','jpeg','png','gif','tif','tiff','xcf','psd']
		self._Pdf=self._Ps=['pdf','ps']
		self._Videos=self._Ps=['avi','mov','mpg','mpeg','flv','mp4','ogg','webm']
		self._Programmation=['py','c','cpp','pyc']
	"""
	def __dir__(self):
		print(self._Images)
		print(self._Pdf)
		print(self._Videos)
		print(self._Programmation)
	"""	
		

			
			
			
			
			
class CFichierContenu(object):
	""" CLASSE CFichierContenu(CFichiers(str(nom))) : contenu d'un fichier fichier """
	
	def __init__(self,fich=''):
		Tprint('-* CFichierContenu.__init__(fich)')		
		self._fich=CFichiers(fich)
		self._Lignes=None
		self._f=None
		
		self._ouvert=False
		self.OuvreFichier()
	
		#self.aide=_FonctionDuProgramme
		pass
		
	def aide(self):
		print(_FonctionDuProgramme)		
		
	def OuvreFichier(self):#V1.2
		Tprint('-* CFichierContenu.OuvreFichier()')
		try:
			self._f=open(self._fich._fich,'r')
			self._ouvert=True #1.3.1
		except:
			print('(WW) impossible d\'ouvrir le fichier "'+self._fich._fich+'"')
			self._ouvert=False
			
		
	def Lignes(self,SautDeLignesInclus=False):
		""" renvoie un tableau de str contenant \n ou pas V1.1 """
		Tprint('-* CFichierContenu.Lignes(SautDeLignesInclus='+str(SautDeLignesInclus)+')=>self._Lignes')#1.3.1
		self._Lignes=[]
		if self._f==None:
			#1.3.1print(self._f)
			self.OuvreFichier()
			
		if SautDeLignesInclus:
			for ligne in self._f:			
				self._Lignes.append(ligne)			
		else:
			for ligne in self._f:			
				self._Lignes.append(ligne[0:-1])
					
		
		return self._Lignes

	def FermeFichier(self):	
		Tprint('-* CFichierContenu.FermeFichier()')
		try:
			self._f.close()
		except:
			pass	
		self._f=None



	def ContenuEnUneLigne(self,SautDeLignesInclus=True):
		Tprint("'-* CFichierContenu.ContenuEnUneLigne()===CFichierContenu.UneLigne() méthode 1=>self._UneLigne")
		return self.UneLigne(SautDeLignesInclus)

	def UneLigne(self,SautDeLignesInclus=True):#méthode 1 #1.2.2
		Tprint("'-* CFichierContenu.UneLigne() méthode 1=>self._UneLigne")
		UneLigne="".join(self.Lignes(SautDeLignesInclus))
		self._UneLigne=UneLigne
		return UneLigne
		
	def UneLigne2(self,SautDeLignesInclus=True):#méthode 2 #1.2.2
		Tprint("'-* CFichierContenu.UneLigne2() méthode 2=>self._UneLigne2")
		l=self.Lignes()
		UneLigne=""
		for li in l:
			UneLigne+=li+"\n"*(SautDeLignesInclus==True)#1.2.2
			#UneLigne+=li+"\n"# < 1.2.2
		self._UneLigne2=UneLigne
		return UneLigne
		

	def Lignes0(self):
		""" renvoie un tableau de str contenant \n <=V1.0 """
		Tprint('-* CFichierContenu.Lignes0')
		self._Lignes=[]
		if self._f==None:
			self.OuvreFichier()
		for ligne in self._f:
			self._Lignes.append(ligne)		
		return self._Lignes
		

	

	
	def CoupeEnDeux(self,coupure=' ',CoupureIncluse=False):#V1.1.6
		""" CoupeEnDeux(coupure=' ',CoupureIncluse=False|'Gauche'|'Centre'|'Droite') """
		Tprint('-* CFichierContenu.CoupeEnDeux V1.1.6 ')
		UneLigne=self.UneLigne(False)
		return CoupeLigneEnDeux(UneLigne,coupure,CoupureIncluse)
		'''
		s1,s2=re.split(coupure,UneLigne,1)
		
		if CoupureIncluse==False:
			Res=[s1,s2]			
		if CoupureIncluse=='Gauche':
			Res=[s1+coupure,s2]
		if CoupureIncluse=='Centre':
			Res=[s1,coupure,s2]
		if CoupureIncluse=='Droite':
			Res=[s1,coupure+s2]
		'''
		return Res
		
		
		
		
		
	def ZZCoupe(self,coupure=' ',CoupureIncluse="Droite"):#V1.1.6 equivalent de cut en bash
		""" CoupeEnDeux(coupure=' ',CoupureIncluse=False|'Gauche'|'Centre'|'Droite') """
		Tprint('-* CFichierContenu.CoupeEnDeux V1.1.6 ')
		UneLigne=self.UneLigne(False)
		Res=[UneLigne]
		#print(-1,Res[0])
		i=0
		#for i in range(5):
		while re.search(coupure,Res[-1])!=None:
			i+=1
			#print('(Res[-1]',Res[-1])
			Res=Res[0:-1]+CoupeLigneEnDeux(Res[-1],coupure,False)
			#print(i,Res)			
			
		for i in range(1,len(Res)):
			Res[i]=coupure+Res[i]
		#print(Res)	
		return Res	
		
	

		# attention quleques érreurs comme si on cherche <body le > on obtient <body> et >
	def DecoupeEnDeux(self,coupure="begin{document}",_Lignes=None,CoupureIncluse=True,typeuh="TABLEAU"):
		""" ressort resultat=[  ['amchin\n machin\n begin{document}]',['lignes restantes','l2'..]] \n DecoupeEnDeux(self,coupure="begin{document}")"""
		Tprint('-* CFichierContenu.DecoupeEnDeux V1.1 ')
		if typeuh!="STRING":
			typeuh="TABLEAU"
		
		if _Lignes==None:
			if self._Lignes==None:
				self.Lignes()
			_Lignes=self._Lignes
		resultat=[[],[]]
		
		n=0
		while n+1<len(_Lignes) and coupure not in _Lignes[n]:
			n+=1
		if n == len(_Lignes)-1 and coupure not in _Lignes[n]:
			#print(n)
			resultat[0]=_Lignes
			resultat[1]=['']
			Dprint('Coupure'+coupure+' NonTrouvee')
		else:
			resultat[0]=_Lignes[0:n]			
			ligne=_Lignes[n]
			if CoupureIncluse==True:
				res=re.sub("(.*"+coupure+")","\g<1>",ligne)
				if re.sub(".*"+coupure+"(.*)","\g<1>",ligne)=="":
					n=n+1				
			else:
				res=re.sub("(.*)"+coupure,"\g<1>",ligne)				
			resultat[0].append(res)
			
			dech=""			
			if CoupureIncluse!=True:
				dech=re.sub("("+coupure+".*)","\g<1>",ligne)
			else:
				dech=re.sub(coupure+"(.*)","\g<1>",ligne)
					
			resultat[1]=[dech]
			if n+1< len(self._Lignes)+1:
				resultat[1]+=_Lignes[n+1:]
		
		if typeuh=="STRING":
			self._DecoupeEnDeux=[TableauToString(resultat[0]),TableauToString(resultat[1])]			
		if typeuh=="TABLEAU":
			self._DecoupeEnDeux=resultat
		return self._DecoupeEnDeux
		
	def ZZTrouveIntervalleEnLignes(self,debut="begin{document}",fin="end{document}",NbMaxIntervalles=1): #ne prend pas en compte "FIn Debut Fin Debut" dans la lmême ligne
		""" ressort [['begin{document}',''kl','lkmlk','end{document}']] \n TrouveIntervalleEnLignes(self,debut="begin{document}",fin="end{document}",NbMaxIntervalles=1): """
		Tprint('-* CFichierContenu.TrouveIntervalleEnLignes V1.0')
		if self._Lignes==None:
			self.Lignes()
		
		self.Entete=""
		self.Dechets=""
		self.Corps=""	
			
		NbIntervalles=0
		Intervalles=[]
		Intervalle=[]
		# POSITIONS : 0=(recherche debut) [debut 1=(recherche fin) fin ]     2 ...
		POSITION=0
		for ligne in self._Lignes:
			tmp=ligne
			Dprint('=========================================')
			#Dprint("lignes,Intervalles = ",self._Lignes,Intervalles)
			Dprint("ligne,POSITION = ",ligne,POSITION)
			if debut in tmp or fin in tmp:
				while (debut in tmp and POSITION % 2 == 0 ) or (fin in tmp and POSITION % 2 == 1) and (NbIntervalles<NbMaxIntervalles):
					Dprint("1 tmp",POSITION,tmp)
					if POSITION % 2 == 0:					
						while (debut in tmp)and (NbIntervalles<NbMaxIntervalles):
							if fin not in tmp :							
								Intervalle+=[re.sub(".*"+debut,debut,tmp)]
								tmp=re.sub(".*"+debut,"",tmp)
								POSITION+=1
								Dprint("2 tmp",POSITION,tmp)
							if fin in tmp :							
								exit(157)
								Intervalle+=[re.sub(fin+".*",fin,re.sub(".*"+debut,debut,tmp))]
								tmp=re.sub(".*"+debut,"",tmp)
								Intervalles+=[Intervalle]
								NbIntervalles+=1
								Dprint("4 tmp",POSITION,tmp)
								Intervalle=[]
								POSITION+=2
						Dprint("6 tmp",POSITION,tmp)			
					else: #POSITION % 2 == 1:					
						while (fin in tmp)and (NbIntervalles<NbMaxIntervalles):
							Dprint("zz"+tmp+"zz")
							NbIntervalles+=1	
							if debut not in tmp :
								Dprint("bb"+tmp+"bb")	
								Intervalle+=[re.sub(fin+".*",fin,tmp)]
								tmp=re.sub(".*"+fin,"",tmp)
								Intervalles+=[Intervalle]
								Intervalle=[]
								POSITION+=1
								Dprint("3 tmp",POSITION,tmp)
							if debut in tmp :
								Dprint("aa"+tmp+"aa")	
								Intervalle+=[re.sub(fin+".*",fin,tmp)]
								Intervalles+=[Intervalle]
								Dprint(Intervalle)
								Intervalle=[]						
								Intervalle=[re.sub(".*"+debut,debut,tmp)]
								tmp=re.sub(".*"+debut,"",tmp)
								POSITION+=2
								Dprint("5 tmp",POSITION,tmp)
							Dprint("7 tmp",tmp)			
			else:
				if POSITION % 2 == 1:
					Intervalle+=[tmp]
					Dprint("9 tmp",POSITION,tmp)
			if POSITION == 0:
					self.Entete+=tmp	
			if POSITION == 2:
					self.Dechets+=tmp	
		self.Corps=""			
		for t in Intervalle:
			self.Corps+=t
						
		"""				
		n=0				
		for I in Intervalles:
			print("=============================")
			print(n)
			n+=1
			print(I)
		"""	
		self._Intervalles=Intervalles
		return self._Intervalles

	def EcritFichier(self,StrFich,Contenu):
		""" écrire le fichier """
		Tprint('-* CFichierContenu.EcritFichier')
		f=open(StrFich,'w')
		Dprint(type(f))
		if isinstance(Contenu,str):
			print(Contenu,file=f)
			
		if isinstance(Contenu,list):
			for C in Contenu:
				print(C,file=f)
		f.close()

	
def doc():
	a=CExtensions()
	print(a)
	print("--"*5,a.__doc__)
	print("--"*5,dir(a))
	print("--"*5,[f for f in dir(a) if '__' not in f])
	
	a=CFichierContenu
	print(a)
	print("--"*5,a.__doc__)
	print("--"*5,dir(a))
	print("--"*5,[f for f in dir(a) if '__' not in f])
	

def CoupeLigneEnDeux(UneLigne,coupure=' ',CoupureIncluse=False):#1.1.6 peut etre mis ailleur dans Cstring
	""" CoupeLigneEnDeux(coupure=' ',CoupureIncluse=False|'Gauche'|'Centre'|'Droite') """
	Tprint('-* CFichierContenu.CoupeLigneEnDeux V1.1.6 ')
	
	s1,s2=re.split(coupure,UneLigne,1)
	
	if CoupureIncluse==False:
		Res=[s1,s2]			
	if CoupureIncluse=='Gauche':
		Res=[s1+coupure,s2]
	if CoupureIncluse=='Centre':
		Res=[s1,coupure,s2]
	if CoupureIncluse=='Droite':
		Res=[s1,coupure+s2]
	
	return Res	
		
"""
		
import mysql,datetime
import mysql.connector



cnx = mysql.connector.connect(user='ProtonsEtNeutron', password='feclDW0DenfKSHsd',host='127.0.0.1',database='ProtonsEtNeutron')
cursor = cnx.cursor()
#query = ("SELECT first_name, last_name, hire_date FROM employees "    "WHERE hire_date BETWEEN %s AND %s")
temp="SELECT * FROM `objets` ORDER BY id"
cursor.execute(temp)

Rep_pt=

for (rid) in cursor:
	ligne=(list(rid))
	print ( str(ligne[0]) )
	print(ligne)


"""



global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)
	
	fich=CFichierContenu("/home/bruno/Bureau/MATHS/VECTEURS/vecteurs-TS.tex")
	fich.Lignes()
	#print('ppp',fich._Lignes)
	
	
	#V1.1
	fich.DecoupeEnDeux("end{document}")
	print(fich._DecoupeEnDeux[0])
	print('===================================================================================')
	print(fich._DecoupeEnDeux[1])
	print(len(fich._DecoupeEnDeux[0]),len(fich._DecoupeEnDeux[1]))
	
	"""
	#V1.0
	fich.TrouveIntervalleEnLignes("begin{document}","end{document}")		
	fich.FermeFichier()
	fich.EcritFichier('/tmp/ee',fich._Intervalles[0])
	#print('/tmp/ee',fich._Intervalles[0][0])
	"""
	
	sys.exit()

'''
	print('import CFichiersRepertoires')
	print('from CFichiersRepertoires import CFichiersRepertoires,CFichiers')
	print('fich=CFichiers(nomfich)')
	print('  fich._SEP')
	print('  fich._fich , fich.Valide() , fich.RepNom() ,	fich.FichNom() , FichExt  .FichAvantExt')
	print('rep=CFichiers(nomrep)')
	print('  rep._SEP , rep.Contenu() ')
	print('  rep._rep , rep.Valide() , rep.RepNom() ,	rep.FichNom() self.FichAvantExt')
	
	print('Ext=CExtensions()')
	print("		Ext._Images=['jpg','jpeg','png','gif','tif','tiff','xcf','psd'] \n\
		Ext._Pdf=self._Ps=['pdf','ps'] \n\
		Ext._Videos=self._Ps=['avi','mov','mpg','mpeg','flv','mp4','ogg','webm'] \n\
		Ext._Programmation=['py','c','cpp','pyc'] \n\
		rep.ChercheFichierAvecNom(['s-mathematiques-obligatoire-2016-metropole-suj','/ES'],PasDeCasse=False,Operation='OR')\n\
		")
	rep=CRepertoires('/tmp/ANNALES')
	#rep.ChercheFichierAvecExtension('pdf')
	rep.ChercheFichiersAvecNom(['s-mathematiques-obligatoire-2016-metropole-suj','/ES'],PasDeCasse=False,Operation="AND")
	print([f._fich for f in rep._recherche])
	
	
	
	
	
	
	nom='/tmp/aa/bb/cc/dd/ee/ff/gg/bb.jpg'
	a=CFichiers(nom)
	print("CFichiers("+nom+")._FichExt = "+a._FichExt)
	
	
	
	print("CFichiers("+nom+").FichRelativisee('/tmp/aa/bb') = "+CFichiers(nom).FichRelativisee("/tmp/aa/bb"))
	
	
	print(a.__doc__)
'''	
	

			
class zzzCFichierBinaire(object):
	""" CLASSE CFichierBinaire(CFichiers(str(nom))) : contenu d'un fichier fichier """
	def __init__(self,fich=''):
		Tprint('-* CFichierBinaire.__init__(fich)')		
		self._fich=CFichiers(fich)
		self.OuvreFichier()
		self._Lignes=None
		self._f=None
		pass		

	def OuvreFichier(self):#V1.2
		""" ouvre le fichier  """
		Tprint('-* CFichierBinaire.OuvreFichier()')
		try:
			self._f=open(self._fich._fich,'rb')
		except:
			print('(WW) impossible d\'ouvrir le fichier "'+self._fich._fich+'"')
