from __future__ import print_function
# -*- coding: utf-8 -*-

_FonctionDuProgramme="Classe donnant accès aux interactions à N corps \
on commence par z=CDonneesPhysiques(['grav']) : le type de forces \
on choisit des z.ConditionsInitiales(NoDeLExperience,centre=True,VARS=[k])\
avec NoDeLExperience : 0,1,2,'TerreSoleil','3Corps','NCorps'\
on choisit les autres données de l'expérience \n\
z.Experience(fichier=[True,'A1.32.txt'],image=[True,'temp.png',2000,2000])\
on peut changer les valeurs z._xmin=z._ymin=z._zmin=-7.0E7\
	z._xmax=z._ymax=z._zmax=7.0E7 mais alors il faut redémarrer l'image\
	z.InitImage(2000,2000)\
on peut choisir les valeur du dt z._dt=100.0 , le nombre de points 	z._NbDt=int(1000000)\
deux pas d'enregistrements possibles : \
	z._IMAGE_UneCleTousLesNPas=10\
	z._FICH_UneCleTousLesNPas=int(10)\
\n	on lance le programme z.Trajectoire(AfficheTerminal=False)\
\n on peut réenregistrer z.image.Enregistre('machin.png')\
"


print(_FonctionDuProgramme)
_Version="3.2.1"
print("Version:"+_Version)

"""
3.2.2 : lignes 
3.2.1 : ajout de variables pour l'accès extérieur en tant que classe
	z.ConditionsInitiales("3Corps",centre=True,VARS=[k])	
3.2 réécriture pour avoir dans rk4 tous les points qui changent et donc l'accélération aussi
3.0.2 CImage()
3.0.1 ajout des conditions finales relatives aux initiales
3.0 réécriture des classes 

"""

#dossier="/home/bruno/Bureau/PROGRAMMATION/PYTHON/CLASSES"
dossier="/opt/CLASSES"
import sys
if dossier not in sys.path:
    sys.path.append(dossier)
    
import re








##################### debug


_debug_Titres=False # _debug_Titres=True #
_debug=False #_debug=True #
_debug_all=False # _debug_all=True # 

if _debug_all==True:
	_debug_Titres=True
	_debug=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub('.*/','',sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
		
def Dprint(*args, **kwargs):
	if _debug==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
		print('--------------------------')
	
def dprint(*args, **kwargs):
	if _debug==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
		print('--------------------------')	
		
# # # # # # # # # # # # # # # # # # # debug











import CMatrixMatrices
from CMatrixMatrices import *
import CImages
from CImages import *


class CDonneesPhysiques(object):
	""" forces , positions, vitesses """
	def __init__(self,acc=["grav"]):# NbDeCorps=2,G=1.0,dt=1.0,UneCleToutesLesNFrames=1,NbDt=250):
		
		#self._accelerations=[]
		self._Cx=0.0 #frottement		
		self._hbar=1.0 #Js
		self._G=1.0 #grav  self._G=1.0 #grav
		self._c=1.0 #m/s	
		
		self._c=299792458.0
		self._G=6.67408E-11
		self._hbar=6.62607015E-34
		
		if "grav" in acc:
			self._accelerations=[self.accG]
			
			
		#self.ConditionsInitiales(1)
		
	def ZZaccG(self,r1,r2,masse2):#action de 2 sur 1
		""" gravitation : action de 2 sur 1 """		
		r=r1-r2
		a=-self._G/( r.Norme() )**3.0 * r * masse2
		dprint("..52..",r1,r2)
		dprint("..53..",self._G,r.Norme(),r,masse2)
		dprint("..54.a=.",a)
		return a

	def accG(self,PTi,PTj):#action de PTj sur PTi
		""" gravitation : action de 2 sur 1 """		
		r1=PTi._pos
		r2=PTj._pos		
		r=r1-r2
		a=-self._G/( r.Norme() )**3.0 *  PTj._masse * r
		return a
		
		
	def ZZZaccF(self,v,masse):
		""" frottements : a = - Cx V /m  """
		a=-self._Cx*v / masse
		return a
	
	#3.2.1 ajout de VARS
	def ConditionsInitiales(self,NoDeLExperience=0,centre=True,VARS=None):
		""" INITIALISATION des masses, vitesses, positions , centrage sur le centre de gravité"""
		
		self._xmin=self._ymin=self._zmin=-10.0E7
		self._xmax=self._ymax=self._zmax=10.0E7
			
			
		if NoDeLExperience==0:#Terre + objets
			self._NbDeCorps=3
			self._points=[CPoint(no) for no in range(self._NbDeCorps)]
			masses=[6E24]+[6E20]*(self._NbDeCorps-1)
			for p in range(self._NbDeCorps):
				self._points[p]._masse=masses[p]
				self._points[p]._pos=Vecteur([-1E7*p,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
				
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			for p in range(1,self._NbDeCorps):
				self._points[p]._vit=Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])		

			
			self._xmin=self._ymin=self._zmin=-10.0E7
			self._xmax=self._ymax=self._zmax=10.0E7
			
		if NoDeLExperience==1:#surface de la Terre
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(2)]
			masses=[6.0E24 , 1.0]			
			self._points[0]._pos=Vecteur([0.0,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			self._points[0]._masse=masses[0]
			
			self._points[1]._pos=Vecteur([0.0,0.0,6.371E6]) #Vector((-100.0*p,0.0,0.0))
			#self._points[1]._vit=Vecteur(3)#Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			self._points[1]._vit=Vecteur([0.0,0.0,10.0])
			self._points[1]._masse=masses[1]

		if NoDeLExperience==2:#départ de la Terre
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(2)]
			masses=[6.0E24 , 1.0]			
			self._points[0]._pos=Vecteur([0.0,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			self._points[0]._masse=masses[0]
			
			self._points[1]._pos=Vecteur([6.371E6,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			#self._points[1]._vit=Vecteur(3)#Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			self._points[1]._vit=Vecteur([4000.0,3000.0,0.0])
			self._points[1]._masse=masses[1]
			
			self._xmin,self._xmax=-1000E4,2000E4
			self._ymin,self._ymax=-1000E4,2000E4
			self._zmin,self._zmax=-1000E4,2000E4
			

		#['f=', 65000, ';t=', 65000.0, ';pos(0)=', '[0.0;0.0;8.997148249737847e-17]', ';vit(0)=', '[0.0;0.0;1.5408261852931502e-21]', ';pos(1)=', '[0.0;0.0;188487306.15932888]', ';vit(1)=', '[0.0;0.0;1959.973350414843]', ';E=', '-1.3763317838311195e-05']
		if NoDeLExperience==3:# reutilisation du fichier non utilisatable
			print('reutilisation du fichier non utilisable')
			exit()
			d=['f=', 65000, ';t=', 65000.0, ';pos(0)=', '[0.0;0.0;8.997148249737847e-17]', ';vit(0)=', '[0.0;0.0;1.5408261852931502e-21]', ';pos(1)=', '[0.0;0.0;188487306.15932888]', ';vit(1)=', '[0.0;0.0;1959.973350414843]', ';E=', '-1.3763317838311195e-05']
			e= [  [float(i) for i in (d[j][1:len(d[j])-1]).split(";")] for j in range(5,12,2)]
			p0,v0,p1,v1=[Vecteur(e[i]) for i in range(4)]
			
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(2)]
			masses=[6.0E24 , 1.0]			
			self._points[0]._pos=p0
			self._points[0]._vit=v0
			self._points[0]._masse=masses[0]
			
			self._points[1]._pos=p1
			#self._points[1]._vit=Vecteur(3)#Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[p]._pos).Norme() )**0.5,0.0])
			self._points[1]._vit=v1
			self._points[1]._masse=masses[1]
			
			
		if NoDeLExperience=="TerreSoleil":#Terre + objets
			self._NbDeCorps=2
			self._points=[CPoint(no) for no in range(self._NbDeCorps)]
			masses=[2.0E30,6.0E24]
			for p in range(self._NbDeCorps):
				self._points[p]._masse=masses[p]
			self._points[0]._pos=Vecteur()
			self._points[1]._pos=Vecteur([-150E9,0.0,0.0])
				
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			self._points[1]._vit=Vecteur([0.0,( self._G*self._points[0]._masse/(self._points[0]._pos-self._points[1]._pos).Norme() )**0.5,0.0])

			self._xmin,self._xmax=-1E12,1E12
			self._ymin,self._ymax=-1E12,1E12
			self._zmin,self._zmax=-1000E4,2000E4

		if NoDeLExperience=="3Corps":#Terre + objets
			self._NbDeCorps=3
			self._points=[CPoint(no) for no in range(self._NbDeCorps)]
			masses=[6E20]*(self._NbDeCorps)
			
			for p in range(self._NbDeCorps):
				self._points[p]._masse=masses[p]
				self._points[p]._pos=Vecteur([-1E7*p,0.0,0.0]) #Vector((-100.0*p,0.0,0.0))
			
			self._points[0]._vit=Vecteur(3)#Vector((0.0,0.0,0.0))
			
			u=( self._G*self._points[0]._masse/(self._points[1]._pos).Norme() )**0.5
			self._points[1]._vit=Vecteur([0.0,u,0.0])
			u=( self._G*self._points[0]._masse/(self._points[2]._pos).Norme() )**0.5
			if VARS==None:
				k=1.3
			else:
				k=VARS[0]	
				
			self._points[2]._vit=Vecteur([k*u,k*u,-k*u])
			Dprint("u226=",u)
			
			self._xmin=self._ymin=self._zmin=-10.0E7
			self._xmax=self._ymax=self._zmax=10.0E7			
		
		
		if NoDeLExperience=="NCorps":# VARS=N
			self._NbDeCorps=VARS[0]
			self._points=[CPoint(no) for no in range(self._NbDeCorps)]
			masses=[6E20]*(self._NbDeCorps)
			
			try:
				k=VARS[1]#2.2**0.5
			except:
				k=1.0
				
			self._points[0]._vit=Vecteur(3)	
			for p in range(self._NbDeCorps):
				self._points[p]._masse=masses[p]
				self._points[p]._pos=Vecteur([-1E7*p,0.0,0.0])
				if p>0:
					u=( self._G*self._points[0]._masse/(self._points[p]._pos).Norme() )**0.5
					self._points[p]._vit=Vecteur([u,k**p*u,k**p*u])
				
				
				
		
		for p in range(self._NbDeCorps):
			Dprint("m("+str(p)+"=",self._points[p]._masse)
			Dprint("r("+str(p)+"=",self._points[p]._pos)
			Dprint("v("+str(p)+"=",self._points[p]._vit)

		if centre==True:#centrage sur le centre de gravité
			self.Centrage()
			
			
		self.Init_points=deepcopy(self._points)
		self.Init_Energie=self.Energie()
		
		print('energie initiale = ', self.Init_Energie)


		
	def Centrage(self):
		""" Centrage : r(G) = cste ; p(g) = 0 """
		Tprint("Centrage")
		MOg, Pg , M	= Vecteur(3),Vecteur(3),0.0 # Vector((0.0,0.0,0.0)) , 0.0
		for p in range(self._NbDeCorps):
			Pg+=self._points[p]._masse*self._points[p]._vit
			MOg+=self._points[p]._masse*self._points[p]._pos
			M+=self._points[p]._masse
		
		Vg=1/M*Pg
		Og=1/M*MOg
		Dprint("M,Vg,Og",M,Vg,Og)
	
		for p in range(self._NbDeCorps):
			self._points[p]._vit=self._points[p]._vit-Vg
			self._points[p]._pos=self._points[p]._pos-Og
			Dprint("vit["+str(p)+"]",self._points[p]._vit)

	def Energie(self):		
		return self.Ec()+self.EnergieG()
		
	def EnergieV(self):
		EV=0.0
		for pt in self._points:
			EV += pt.Ec()
		return EV
		
	def Ec(self):
		return self.EnergieV()
		
	def EnergieG(self):
		EG=0.0
		for i in range(self._NbDeCorps-1):
			pt1=self._points[i]
			for j in range(i+1,self._NbDeCorps):
				pt2=self._points[j]
				#EG += - (self._G) * (pt1._masse)*(pt2._masse) / ( (pt1._pos-pt2._pos).length )
				EG += - (self._G) * (pt1._masse)*(pt2._masse) / ( pt1._pos-pt2._pos).Norme() 
				#print('norme=',type(( pt1._pos-pt2._pos).Norme() ))
		return EG
		
		
	# version<3.2
	def RK4_XVT(self,i,j,dt):#Xinit, Vinit, a, dt):#a(x,v,dt) 
		Xinit,Vinit = self._points[i]._pos , self._points[i]._vit
		
		Robj = self._points[j]._pos
		mobj = self._points[j]._masse
		acc=self.accG
		"""Returns final (position, velocity) tuple after
		time dt has passed.

		Xinit: initial position (number-like object)
		Vinit: initial velocity (number-like object)
		a: acceleration function a(x,v,dt) (must be callable)
		dt: timestep (number)"""
		x1 = Xinit
		v1 = Vinit
		a1 = acc(x1, Robj ,mobj)
		
		x2 = Xinit + 0.5*v1*dt
		
		v2 = Vinit + 0.5*a1*dt
		a2 = acc(x2, Robj,mobj)

		x3 = Xinit + 0.5*v2*dt
		v3 = Vinit + 0.5*a2*dt
		a3 = acc(x3, Robj,mobj)

		x4 = Xinit + v3*dt
		v4 = Vinit + a3*dt
		a4 = acc(x4, Robj,mobj)

		dxf = (dt/6.0)*(v1 + 2*v2 + 2*v3 + v4)
		dvf = (dt/6.0)*(a1 + 2*a2 + 2*a3 + a4)

		return dxf,dvf
				
	def RK4(self,dt):#Xinit, Vinit, a, dt):#a(x,v,dt) 
		"""Xinit,Vinit = self._points[i]._pos , self._points[i]._vit
		
		Robj = self._points[j]._pos
		mobj = self._points[j]._masse
		acc=self.accG
		"""
		
		acc=self._accelerations[0]
		#x1 = Xinit 
		#v1 = Vinit
		
		#points1=[CPoint(p) for p in range(self._NbDeCorps)]
		points1 = deepcopy(self._points)
		
		points2=[CPoint(p) for p in range(self._NbDeCorps)]
		points3=[CPoint(p) for p in range(self._NbDeCorps)]
		points4=[CPoint(p) for p in range(self._NbDeCorps)]		
		for p in range(self._NbDeCorps):
			#points1[p]._masse = self._points[p]._masse
			points2[p]._masse = self._points[p]._masse
			points3[p]._masse = self._points[p]._masse
			points4[p]._masse = self._points[p]._masse
			
			
		######### a1 = f(t,y,y')	
		#a1 = acc(x1, Robj ,mobj)	
		#a1=[Vecteur() for p in range(self._NbDeCorps)]	
		a1=[sum([acc(points1[p],points1[j]) for j in range(self._NbDeCorps) if j != p]) for p in range(self._NbDeCorps)]
		
		
		
		######### a2 = f(t+dt/2 , y+0.5 dt y' , y'+0.5 dt a1)	
		for p in range(self._NbDeCorps):
			#x2 = Xinit + 0.5*v1*dt
			points2[p]._pos=points1[p]._pos + 0.5 * dt * points1[p]._vit
						
			#v2 = Vinit + 0.5*a1*dt
			points2[p]._vit=points1[p]._vit + 0.5 * dt * a1[p]
			
		#a2 = acc(x2, Robj,mobj)
		a2= [ sum([acc(points2[p],points2[j]) for j in range(self._NbDeCorps) if j != p])for p in range(self._NbDeCorps)]
		
		
		######### a3 = f(t+dt/2 , y+0.5 dt y' + 0.25 dt^2 a1 , y'+0.5 dt a2)
		for p in range(self._NbDeCorps):
			#x3 = Xinit + 0.5*v2*dt
			points3[p]._pos=points2[p]._pos + 0.25 * dt**2.0 * a1[p]
			#v3 = Vinit + 0.5*a2*dt
			points3[p]._vit=points1[p]._vit + 0.5 * dt * a2[p]
			
		a3=[ sum([acc(points3[p],points3[j]) for j in range(self._NbDeCorps) if j != p])for p in range(self._NbDeCorps)]
		#a3 = acc(x3, Robj,mobj)


		######### a4 = f(t+dt , y+ dt y' + 0.5 dt^2 a2 , y'+ dt a3)
		for p in range(self._NbDeCorps):
			points4[p]._pos = points1[p]._pos + dt * points1[p]._vit + 0.5 * dt**2.0 * a2[p]
			points4[p]._vit=points1[p]._vit + dt * a3[p]
		a4=[ sum([acc(points4[p],points4[j]) for j in range(self._NbDeCorps) if j != p])for p in range(self._NbDeCorps)]	
			
		'''
		x4 = Xinit + v3*dt
		v4 = Vinit + a3*dt
		a4 = acc(x4, Robj,mobj)
		'''
		######## 
		'''
		dxf = (dt/6.0)*(v1 + 2*v2 + 2*v3 + v4)
		dvf = (dt/6.0)*(a1 + 2*a2 + 2*a3 + a4)
		'''
		
		
		######## dx = h y' + h^2/6 (a1+a2+a3)
		dx = [ dt * points1[p]._vit + dt**2.0/6 *( a1[p] + a2[p] +a3[p] )  for p in range(self._NbDeCorps)]
		######## dv = h/6 ( a1+2a2+2a3+a4)
		dv = [ dt / 6.0 * ( a1[p] + 2* a2[p] +2*a3[p] + a4[p] ) for p in range(self._NbDeCorps) ]
		
		return dx,dv
				

		
	def ZZZRK4_XVT(self,i,j,dt):#Xinit, Vinit, a, dt):#a(x,v,dt)
		Xinit,Vinit = self._points[i]._pos , self._points[i]._vit
		
		Robj = self._points[j]._pos
		mobj = self._points[j]._masse
		acc=self.accG
		"""Returns final (position, velocity) tuple after
		time dt has passed.

		Xinit: initial position (number-like object)
		Vinit: initial velocity (number-like object)
		a: acceleration function a(x,v,dt) (must be callable)
		dt: timestep (number)"""
		x1 = Xinit
		v1 = Vinit
		a1 = acc(x1, Robj ,mobj)
		
		x2 = Xinit + 0.5*v1*dt
		
		v2 = Vinit + 0.5*a1*dt
		a2 = acc(x2, Robj,mobj)

		x3 = Xinit + 0.5*v2*dt
		v3 = Vinit + 0.5*a2*dt
		a3 = acc(x3, Robj,mobj)

		x4 = Xinit + v3*dt
		v4 = Vinit + a3*dt
		a4 = acc(x4, Robj,mobj)

		dxf = (dt/6.0)*(v1 + 2*v2 + 2*v3 + v4)
		dvf = (dt/6.0)*(a1 + 2*a2 + 2*a3 + a4)

		return dxf,dvf
		
	#Exp = 0	
	#t=1.0	Tps=8,1+0,3*Nbdt ; Nbdt=1/dt
	#dt=1.0 Erel=129.7377393245697	8,304
	#dt=0.1 Erel=83.03220395743847	11,228
	#dt=0.01 Erel=78.36165162920952	38,292
	#dt=0.001 Erel=77.8945964500308	309,276
	
	# tps estimé : 8,1 + 0,3 *Nbt / 25 * N^2
	
	def Experience(self,fichier=[True,'/tmp/ee'],image=[True,'/tmp/ee.png',1000,1000],VoitImageTemporaire=False):
		self._ibf={"fichier":fichier[1],"image":image[1]}
		self.VoitImageTemporaire=VoitImageTemporaire
		self._dt=1000.0
		self._NbDt=int(1E8)
		
		self._FICH_UneCleTousLesNPas=int(1000)
		self._IMAGE_UneCleTousLesNPas=1
		
		self._t=self._dt*self._NbDt		
		
		if fichier[0]==True:
			self.InitFichier(self._ibf["fichier"])
		if image[0]==True:
			lignes,colonnes=image[2],image[3]
			self.InitImage(lignes,colonnes)
	
	def InitFichier(self,fichier):
		if True==True:#if self._ibf["fichier"]==True:
			print("création du fichier ",fichier)
			self._fich=open(fichier,'w')#open(fichier[1],"w")
			self._html=[]
			self._html+=["_dt=",self._dt]
			self._html+=["_NbDt=",self._NbDt]
			self._html+=["_t=",self._t]
			self._html+=["_t=",self._t]
			self._html+=["Einit=", self.Init_Energie]
					
			"""
			for h in self._html:
				print(h,file=self._fich)
			"""
			print([self._html],file=self._fich)
			self._html=[]
			
	def InitImage(self,lignes=1000,colonnes=1000):
		if True==True:#if self._ibf["fichier"]==True:
			
			print("création du fichier '"+self._ibf['image']+"', ",str(lignes),"x",str(colonnes))
			self.image=CImage()
			self.image.CreeUneImage(lignes,colonnes)
			
			
			## rmin et rmax : voir conditions initiales
			self.image._xmin,self.image._xmax = self._xmin,self._xmax
			self.image._ymin,self.image._ymax = self._ymin,self._ymax
			self.image._zmin,self.image._zmax = self._zmin,self._zmax

						
	def Trajectoire(self,AfficheTerminal=False,AugmentePrecision=False):
		""" calculs et affichages et images  à proprement dit """
		N=self._NbDeCorps
		self.EnregistreFrame(0,AfficheTerminal=AfficheTerminal)
		self.FrameSurImage(PosRel=False)
		
		if AugmentePrecision==False:
			NouveauPas=self.NouveauPas
		else:	
			NouveauPas=self.NouveauPasPrecis
		
		for f in range(1,self._NbDt+1):
			dprint('f=',f)
			NouveauPas()#self.NouveauPas()
			
			""" FICHIER """
			if f % self._FICH_UneCleTousLesNPas==0:# and self._ibf["fichier"]==True:
				#print('.',end="")
				self.EnregistreFrame(f,AfficheTerminal=AfficheTerminal)
			
			""" image """
			if f % self._IMAGE_UneCleTousLesNPas==0:				
				self.FrameSurImage(PosRel=False)
				
			
				
				
				"""
				tmp=["f=",f]
				for i in range(N):
					tmp+=[";pos("+str(i)+")=",str(self._points[i]._pos-self.Init_points[i]._pos)]
					tmp+=[";vit("+str(i)+")=",str(self._points[i]._vit-self.Init_points[i]._vit)]
				self._html+=[tmp]		
				#print("---",self.Energie())
					#print("+++",self.Ec())
					#print("***",self.EnergieG())
					
				"""
				
			#print(self._DP._points[1]._pos.T())
			
		""" FICHIER 
		if True==True:#if self._ibf["fichier"]==True:
			for h in self._html:
				print(h,file=self._fich)
		"""	
		self._fich.close()	
		self.image.Enregistre(self._ibf['image'])
		print('fin trajectoire')
	
	def EnregistreFrame(self,f,PosRel=False,VitRel=False,EnerRel=True,AfficheTerminal=False):
		N=self._NbDeCorps
		tmp=["f=",f,";t=",f*self._dt]
		for i in range(N):
			tmp+=[";pos("+str(i)+")=",str(self._points[i]._pos-self.Init_points[i]._pos*(PosRel==True))]
			tmp+=[";vit("+str(i)+")=",str(self._points[i]._vit-self.Init_points[i]._vit*(VitRel==True))]
		tmp+=[";E"+("rel"*(EnerRel==True))+"=",str(self.Energie()-self.Init_Energie*(EnerRel==True))]
		
		print(tmp,file=self._fich)
		#['f=', 65000, ';t=', 65000.0, ';pos(0)=', '[0.0;0.0;8.997148249737847e-17]', ';vit(0)=', '[0.0;0.0;1.5408261852931502e-21]', ';pos(1)=', '[0.0;0.0;188487306.15932888]', ';vit(1)=', '[0.0;0.0;1959.973350414843]', ';E=', '-1.3763317838311195e-05']
			
		#self._html+=[tmp]
		
		if AfficheTerminal==True:
			try:
				print(tmp+["DE/E=",(self.Energie()-self.Init_Energie)/self.Init_Energie])
			except:
				print(tmp)
	
	
	def FrameSurImage(self,PosRel=False):
		N=self._NbDeCorps
		for i in range(N):
			p=( self._points[i]._pos-self.Init_points[i]._pos*(PosRel==True) )._mat
			x,y=p[0,0],p[1,0]
			#print("x,y=",x,y)

			self.image.PointSurImage(x,y,i)
			'''
			p1 , p2 = self.Anciens_points[i]._pos , self._points[i]._pos
			x1,y1,x2,y2=p1[0,0],p1[1,0],p2[0,0],p2[1,0]
			self.image.Ligne(x1,y1,x2,y2)
			'''
			
			if self.VoitImageTemporaire==True:
				self.image.Enregistre(self._ibf['image'])
	


	def NouveauPasPrecis(self):
		N=self._NbDeCorps
		dr,dv=self.RK4(self._dt)
		
		############# self.Anciens_points=deepcopy(self._points)
		self.Anciens_points=[CPoint(no) for no in range(N)]		
		for i in range(N):
			self.Anciens_points[i]._pos = self._points[i]._pos
			self.Anciens_points[i]._vit = self._points[i]._vit	
		
		
		
		self.NouveauxPoints(dr,dv) #calcule les nouveau point
		self.TransformePoints() # _NouveauxPoints-> _DP._points	
		DEE=abs((self.Energie()-self.Init_Energie)/self.Init_Energie)
		while DEE > 0.01 : 
			self._dt=self._dt*0.5
			self._NbDt=self._NbDt*2
			
			############# self._points=deepcopy(self.Anciens_points)
			for i in range(N):
				self._points[i]._pos = self.Anciens_points[i]._pos
				self._points[i]._vit = self.Anciens_points[i]._vit	
			
			
			print( "Changement de dt. dt=" , self._dt , )
			dr,dv=self.RK4(self._dt)
			#self.Anciens_points=deepcopy(self._points)
			self.NouveauxPoints(dr,dv) #calcule les nouveau point
			self.TransformePoints() # _NouveauxPoints-> _DP._points	
			DEE=abs((self.Energie()-self.Init_Energie)/self.Init_Energie)
		
		"""
		self.NouveauxPoints(dr,dv) #calcule les nouveau point
		self.TransformePoints() # _NouveauxPoints-> _DP._points	
		"""
		
		
		
	def NouveauPas(self):
		N=self._NbDeCorps
		

		"""
		# version<3.2
		#dr=[Vector((0.0,0.0,0.0)) for i in range(N)]
		dr=[Vecteur([0.0,0.0,0.0]) for i in range(N)]
		#dv=[Vector((0.0,0.0,0.0)) for i in range(N)]
		dv=[Vecteur([0.0,0.0,0.0]) for i in range(N)]		
		
		for i in range(N):
			for j in range(N):
				if i != j:
					#print(i,j)
					ddr,ddv=self.RK4_XVT(i,j,self._dt)#Xinit, Vinit, a, dt)
					#print(dr[i],dr)
					dr[i] += ddr
					dv[i] += ddv
		"""
		
		#V=3.2
		dr,dv=self.RK4(self._dt)
		
			
		#print(ddr)
		
		self.NouveauxPoints(dr,dv) #calcule les nouveau point
		self.TransformePoints() # _NouveauxPoints-> _DP._points
		
	def NouveauxPoints(self,dr,dv):
		N=self._NbDeCorps
		self._NouveauxPoints=[CPoint(no) for no in range(N)]		
		for i in range(N):
			self._NouveauxPoints[i]._pos = self._points[i]._pos + dr[i]
			self._NouveauxPoints[i]._vit = self._points[i]._vit + dv[i]					
		return self._NouveauxPoints			
					
	def TransformePoints(self):
		N=self._NbDeCorps
		for i in range(N):
			self._points[i]._pos = self._NouveauxPoints[i]._pos
			self._points[i]._vit = self._NouveauxPoints[i]._vit

class CPoint(object):
	def __init__(self,no):
		self._no=no
		self._pos=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._vit=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._masse=1.0
		
		self._couleur=couleur(no)
				
		self._charge=0.0
		
		self._typeuh="point"#sphère/cube
		self._dimensions=Vecteur(3)# Vector((0.0,0.0,0.0))
		self._rotation=Vecteur(3)# Vector((0.0,0.0,0.0))

	def EnergieV(self):
		EV = 0.5*(self._masse)* ( (self._vit.T()*self._vit)._mat[0,0] )
		return EV
	
	def Ec(self):
		return self.EnergieV()

def couleur(i):
	col=[ (1.0,0.0,0.0),(0.0,1.0,0.0),(0.0,0.0,1.0),(1.0,1.0,0.0),(0.0,1.0,1.0),(1.0,0.0,1.0)]
	col+=[(0.5,1.0,0.2),(0.5,0.2,1.0),(1.0,0.2,0.5),(1.0,0.5,0.2),(0.2,0.5,1.0),(0.2,1.0,0.5)]
	
	return col[i % len(col)]



global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)



	z=CDonneesPhysiques(["grav"])

	#z.ConditionsInitiales("TerreSoleil",centre=False)
	#z.ConditionsInitiales(0,centre=False)
	z.ConditionsInitiales("3Corps",centre=True)
	

	#z.Experience(fichier=[True,'/tmp/ee.txt'],image=[True,'/tmp/ee.png',1000,1000]):		
	z.Experience()
	
	z.Trajectoire(AfficheTerminal=True)
	
	print( z.Init_Energie , z.Energie() )
	sys.exit()
