#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="Trier des tableaux"
#print(_FonctionDuProgramme)
_Version="1.0"
#print("version:"+_Version)
import re
import os
##################### debug
import sys

_debug_Titres=True # _debug_Titres=False
_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+sys.argv[0]+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(ligne):
	if _debug_all==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

class CTableau(object):
	""" CLASSE CTableau(Tableau) """
	def __init__(self,tableau=[2,1,0]):
		self._table=tableau
		pass#self._repertoire=_rep

def IndiceMin(A,i):
	mini=i
	for k in range(i+1,len(A)):
		if A[k] < A[mini] :
			mini = k
	return mini




class CTris(object):
	""" CLASSE CTris(tableau) """
	def __init__(self,tableau=[2,1,0]):
		self._table=tableau
		pass#self._repertoire=_rep
	def Tri1(self):
		""" CLASSE CTris.Tri1() """	
		pass
	def TriSelection(self):
		
		A=self._table		
		for i in range(len(A)-1):
			indmin = IndiceMin(A,i)
			A[i],A[indmin] = A[indmin],A[i]
		return A		
	def TriInsertion(self):
		""" CLASSE CTris.TriInsertion() """	
		#Tprint(" CLASSE CTris.TriInsertion() ")
		A=self._table
		for j in range(len(A)):
			element=A[j]
			i=j-1
			while (i>=0)&(A[i]> element):
				A[i+1]=A[i]
				i-=1
			A[i+1]= element
		return A
	def TriABulle(self):
		A=self._table
		for i in range(0,len(A)-1):
			for j in range(len(A)-1,i,-1):
				if A[j]<A[j-1]:					
					A[j],A[j-1]=A[j-1],A[j]
		return A			

	def TriRapide(self):	
		"""
		a=dir(sys)
		print([i for i in a if "ursion" in i])		
		print(sys.getrecursionlimit())	
		"""
		rec=sys.getrecursionlimit()
		sys.setrecursionlimit(len(self._table)*10)
		
		def ATriRapide(A,BordG =0,BordD = None,n=0):
			print(n,file=_Log)
			if BordD==None:
				BordD=len(A)-1
			if BordG<BordD:
				IndP=AIndicePivot(A,BordG,BordD)
				ATriRapide(A,BordG,IndP-1,n+1)
				ATriRapide(A,IndP+1,BordD,n+1)
			return A			
		def AIndicePivot(A,BordG,BordD):
			i=BordD+1
			for j in range(BordD,BordG,-1):
				if A[j]>=A[BordG]:
					i-=1
					A[i],A[j]=A[j],A[i]
			A[i-1],A[BordG]=A[BordG],A[i-1]
			return i-1
		res=ATriRapide(self._table)
		sys.setrecursionlimit(rec)	
		return res


'''
print ( os.path.split('/tmp/bb.jpg') )
('/tmp', 'bb.jpg')
print ( os.path.splitext('/tmp/bb.jpg') )
('/tmp/bb', '.jpg')


print ( os.path.split('/tmp/bb/') )
('/tmp/bb', '')
print ( os.path.splitext('/tmp/bb/') )
('/tmp/bb/', '')



print ( o.split('/tmp/bb') )
('/tmp', 'bb')
print ( os.path.splitext('/tmp/bb') )
('/tmp/bb', '')

'''		
class ZZCFichiers(object):
	def __init__(self,fich=''):
		Tprint('fich.__init__()')
		self._SEP='/'	
		self._fich=fich
		pass#self._repertoire=_rep
	def Valide(self):
		Tprint('fich.Valide()')
		resultat=None
		if os.path.isfile(self._fich):
			resultat=True
		if not os.path.isfile(self._fich):
			resultat=False
		return resultat
	def RepNom(self):#'/tmp'
		Tprint('fich.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
	def FichNom(self):#bb.jpg
		Tprint('fich.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
		

class ZZCRepertoires(object):
	def __init__(self,rep=''):
		self._SEP='/'	
		self._Fichs=[]
		self._FichsRec=[]
		self._Reps=[]
		self._RepsRec=[]		
		while rep[-1]==self._SEP:
			rep=rep[:-1]
		self._rep=rep
		pass
		
	def Valide(self):
		Tprint('rep.Valide()')
		resultat=None
		if os.path.isdir(self._rep):
			resultat=True
		if not os.path.isdir(self._rep):
			resultat=False
		return resultat
		
	def Contenu(self):		
		Tprint('rep.Contenu()')
		for root, reps, files in os.walk(self._rep):
			for fich in files: #page038.jpg 
				self._FichsRec.append(CFichiers(os.path.join(root, fich)))	
				fullurl = os.path.join(root, fich) #/home/aa/Tome1/page038.jpg
				print(fullurl)
			for rep in reps:
				self._RepsRec.append(CRepertoires(os.path.join(root, rep)))	
				fullurl = os.path.join(root, rep) #/home/aa/Tome1/page038.jpg
				print(fullurl)
				
	def RepNom(self):#'/tmp'
		Tprint('rep.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
		
	def FichNom(self):#rep1
		Tprint('rep.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
				
					


#self.thumbs=os.listdir(rep)
#(os.path.splitext(i)[1])[1:]
#self.thumbs=[ i for i in self.thumbs if ((os.path.splitext(i)[1])[1:]).lower() in SuffixesImages ]		#AfficheImagesAvecLegendes
def Temps(fonction):
	t1=time.time()
	res=fonction()
	t2=time.time()
	t=t2-t1
	#print(t,' secondes')
	return t,res

def Melange(table):
	n=len(table)
	for i in range(10*n):
		a,b=randint(0,n-1),randint(0,n-1)
		table[a],table[b]=table[b],table[a]	
	return table	

def Test(tri,fonction):		
	#tableR=[list(range(n)) for n in [10,100,1000,10000,1000*100,1000*1000]]
	#tableM=[Melange(table) for table in tableR]
	
	
	#test sur une table triée
	#for table in tableR:
	#for table in tableR:		
	for n in [10,100,1000,10000,1000*100,1000*1000]:
		print('n=',n)
		tri._table=list(range(n))
		
		tps1=Temps(fonction)[0]
		print(re.sub("\.",",",str(tps1)))
		
		
		"""
		
				
				
		print(tps1)
		del res1
		#print(table)
		
		#print(table)
		"""
		tri._table=Melange(tri._table)
		tps2=Temps(fonction)[0]
		#tps2,res2=Temps(fonction)	
		
		print(re.sub("\.",",",str(tps2)),'\n')
		"""
		#test sur une table non triée
		Melange(table)
		tri=CTris(table)
		tps2,res2=Temps(tri.TriSelection)	
		print(tps2)
		del res2
		"""
'''
n sur trié--	-        10          -	-     100         -	-     1000        -	-      10000     -
Triselection	2.2411346435546875e-05	0.00098419189453125	0.10192441940307617	10.369022607803345

		
		
'''
global main
import random
from random import randint
random.seed=15892
import time
if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)


	print('import CTris')
	print('CTris._table=[0,1,2]')
	print('CTris.TriInsertion()  : le plus rapide si rangé')
	print('CTris.TriSelection()')
	print('CTris.TriABulle()')
	print('CTris.TriRapide() : le plus rapide si non rangé')
	'''
	n=1000
	table=list(range(n))
	#print(table)
	for i in range(10*n):
		a,b=randint(0,n-1),randint(0,n-1)
		table[a],table[b]=table[b],table[a]
	#print(table)
	table=list(range(n))
	tri=CTris(table)
	
	tps,res=Temps(tri.TriSelection)
	print(res)
	'''
	tri=CTris()
	#Test(tri,tri.TriInsertion)
	#Test(tri,tri.TriSelection)
	Test(tri,tri.TriABulle)
	Test(tri,tri.TriRapide)
	
	sys.exit()


