#!/usr/bin/python3
# -*- coding: utf-8 -*-
#from __future__ import print_function
_FonctionDuProgramme="Lire dex xml\n https://docs.python.org/3/library/xml.dom.minidom.html#module-xml.dom.minidom"
#print(_FonctionDuProgramme)
_Version="1.0.1"
#print("version:"+_Version)
import re
import os
##################### debug
import sys
from xml.dom import minidom
_debug_Titres=True # _debug_Titres=False
_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+re.sub(".*/","",sys.argv[0])+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
def Dprint(ligne):
	if _debug_all==True:
		print(ligne)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug
# ajout de doc + Tprint sed -e 's/^\(.*\)\(def\ \)\(.*\)$/\1\2\3\n\1\t"""-*\3"""\n\1\tTprint("\3")/' -i aa.py
class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""


DicoFonctions=br_CDICO()
DicoClasses=br_CDICO()

class CXml(object):
	""" CLASSE CXml(object) """
	def __init__(self,fich=None):
		""" CXml.__init__(fich) """
		self._doc = None
		self._root = None
		if fich!=None:
			self._doc = minidom.parse(fich)
			#self._doc = minidom.parse('/home/bruno/Bureau/BoulotEnCours/2019-ba-site/analyse du code/RAPPORT/1907559.xml')#/tmp/a.xml')
			self._root = self._doc.documentElement

	def ChercheTag(self,AChercher="root",Element="root",NonVide=True):
		""" CXml.ChercheTag AChercher="motachercher",Element="root"|Unelement,NonVide=True|False (renvoie les résultats vides ) """
		if Element=="root":
			Element=self._root
		res=Element.getElementsByTagName(AChercher)
		if NonVide==True:
			self._res=[r for r in res if r]
		else:
			self._res=res
		return self._res
		
	def Affiche(self,Element="root"):
		if Element=="root":
			Element=self._root
		print(Element.toprettyxml())
		
	def Enregistre(self,Element="root",fich="/tmp/aaa.xml"):
		if Element=="root":
			Element=self._root
		Element.toprettyxml(fich)
		
		
class Noeud(minidom.Element):
	""" CLASSE Noeud(object) """
	def __init__(self,noeud):
		""" Noeud.__init__(noeud) """
		self._noeud=noeud
		self._doc = None
		self._root = None
		self.TYPES=["rien","ELEMENT_NODE","ATTRIBUTE_NODE","TEXT_NODE","CDATA_SECTION_NODE","ENTITY_NODE","PROCESSING_INSTRUCTION_NODE","COMMENT_NODE","DOCUMENT_NODE","DOCUMENT_TYPE_NODE","NOTATION_NODE"]
		
		self.typeuh()
		self.nom()
		self.items()
		self.enfants()
		
	def typeuh(self):
		self._typeNo=self._noeud.nodeType
		self._type=self.TYPES[self._noeud.nodeType]
		return self._type
		
	def nom(self):
		self._nom=self._noeud.nodeName
		return self._nom
		
	def items(self):
		#<wpt lat="49.8085917" lon="0.4869397">
		self._items=None
		try:
			if self._noeud.hasAttributes():
				self._items=self._noeud.attributes.items()
		except:
			pass		
		return self._items	#[('lon', '0.4869397'), ('lat', '49.8085917')]

		
	def enfants(self,texte=False):
		self._enfants=None		
		try:
			if self._noeud.hasChildNodes():
				self._enfants=[]
				self._enfants=xml.dom.minicompat.NodeList()
				for enf in self._noeud.childNodes:
					if enf.nodeType != minidom.Node.TEXT_NODE or texte==True:
						self._enfants.append(Noeud(enf))

				#self._enfants=self._noeud.childNodes
		except:
			self._enfants=None
		return self._enfants
		
		
DicoClasses['CXml']=CXml.__doc__

		
'''
print ( os.path.split('/tmp/bb.jpg') )
('/tmp', 'bb.jpg')
print ( os.path.splitext('/tmp/bb.jpg') )
('/tmp/bb', '.jpg')


print ( os.path.split('/tmp/bb/') )
('/tmp/bb', '')
print ( os.path.splitext('/tmp/bb/') )
('/tmp/bb/', '')



print ( o.split('/tmp/bb') )
('/tmp', 'bb')
print ( os.path.splitext('/tmp/bb') )
('/tmp/bb', '')

'''		
class ZZCFichiers(object):
	def __init__(self,fich=''):
		Tprint('fich.__init__()')
		self._SEP='/'	
		self._fich=fich
		pass#self._repertoire=_rep
	def Valide(self):
		Tprint('fich.Valide()')
		resultat=None
		if os.path.isfile(self._fich):
			resultat=True
		if not os.path.isfile(self._fich):
			resultat=False
		return resultat
	def RepNom(self):#'/tmp'
		Tprint('fich.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
	def FichNom(self):#bb.jpg
		Tprint('fich.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
		

class ZZCRepertoires(object):
	def __init__(self,rep=''):
		self._SEP='/'	
		self._Fichs=[]
		self._FichsRec=[]
		self._Reps=[]
		self._RepsRec=[]		
		while rep[-1]==self._SEP:
			rep=rep[:-1]
		self._rep=rep
		pass
		
	def Valide(self):
		Tprint('rep.Valide()')
		resultat=None
		if os.path.isdir(self._rep):
			resultat=True
		if not os.path.isdir(self._rep):
			resultat=False
		return resultat
		
	def Contenu(self):		
		Tprint('rep.Contenu()')
		for root, reps, files in os.walk(self._rep):
			for fich in files: #page038.jpg 
				self._FichsRec.append(CFichiers(os.path.join(root, fich)))	
				fullurl = os.path.join(root, fich) #/home/aa/Tome1/page038.jpg
				print(fullurl)
			for rep in reps:
				self._RepsRec.append(CRepertoires(os.path.join(root, rep)))	
				fullurl = os.path.join(root, rep) #/home/aa/Tome1/page038.jpg
				print(fullurl)
				
	def RepNom(self):#'/tmp'
		Tprint('rep.RepNom()')
		self._RepNom=os.path.split(self._rep)[0]
		return self._RepNom
		
	def FichNom(self):#rep1
		Tprint('rep.FichNom()')
		self._FichNom=os.path.split(self._rep)[1]
		return self._FichNom
				
	
global main
import xml

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	#http://www.fil.univ-lille1.fr/~marvie/python/chapitre4.html
	
	doc = minidom.parse('/home/bruno/Bureau/BoulotEnCours/2019-ba-site/analyse du code/RAPPORT/1907559.xml')#/tmp/a.xml')
	root = doc.documentElement
	
	actions=(root.toprettyxml())
	
	exit()
	
	i=1
	for element in root.getElementsByTagName('kill'): #<kill>...
		#print (i,element)
		#print(i ,element.getAttributeNode('kill'))
		print(element.toprettyxml())
		for element2 in element.getElementsByTagName('ratio'):#si <kill><ratio>...
			print(i,element2.toprettyxml())
			i=i+1
	i=1
	
	"""
	for element in root.getElementsByTagName('action'):
		print(i)
		i=i+1
	"""
		
	##affichage classique	
	#print (doc.toprettyxml())
	
	## affichage d'un noeud
	#print(root.nodeName) # report pour <report>
	#print(root.hasAttributes())
	
	
	"""
	print(_FonctionDuProgramme)
	print("version:"+_Version)

	print('import CFonctions')
	for a in DicoFonctions:
		print('from CFonctions import '+a)
		print("  "+DicoFonctions[a])
	for a in DicoClasses:
		print('from CFonctions import '+a)
		print("  "+DicoClasses[a])
	exit()
	print('import CFichiersRepertoires')
	print('from CFichiersRepertoires import CFichiersRepertoires,CFichiers')
	print('fich=CFichiers(nomfich)')
	print('  fich._SEP')
	print('  fich._fich , fich.Valide() , fich.RepNom() ,	fich.FichNom()')
	print('rep=CFichiers(nomrep)')
	print('  rep._SEP , rep.Contenu() ')
	print('  rep._rep , rep.Valide() , rep.RepNom() ,	rep.FichNom()')
	"""
	sys.exit()


